;ͻ
;Metal Warrior III loading picture & music                                    
;Programmed in 6/2000                                                         
;ͼ

                include define.s
                include memory.s

                processor 6502

                org $c000
                incbin lmusic.bin

                org $c800

showpic:        ldx #$00
                sei
showpicloop:    ldy #$34
                sty $01
showpic_lda:    lda $dc00,x
                ldy #$36
                sty $01
showpic_sta:    sta $d800,x
                inx
                bne showpicloop
                inc showpic_lda+2
                inc showpic_sta+2
                lda showpic_sta+2
                cmp #$dc
                bne showpicloop
                cli
                lda #$00
                sta $d015
                sta $d020
                sta $d021
                lda $dd00
                and #$fc
                sta $dd00
                lda #$18
                sta $d016
                lda #$68
                sta $d018
                lda #59
                sta $d011
                lda cfg_usefastload
                beq skipmusic
initmusic:      lda #$01                        ;Init tune 1
                sta $c001
                sei
                lda #<raster
                sta $0314
                lda #>raster
                sta $0315
                lda #$7f                        ;Set timer interrupt off
                sta $dc0d
                lda #$01                        ;Set raster interrupt on
                sta $d01a
                lda #$fa                        ;Set low bits of raster
                sta $d012                       ;position
                lda $dc0d                       ;Acknowledge timer interrupt
                cli
skipmusic:      rts

raster:         inc $d019
                jsr $c000
                inc rastercount
                jmp $ea81

                org $d800
                incbin loadpic.raw
