;ͻ
;Metal Warrior III by Cadaver: all data (variables, tables etc. :-))          
;Started in 10/2000!                                                          
;ͼ

        ;Weapon spritedata
        ;-----------------

weaponsprdata:  incbin weapons.bin




        ;256-byte aligned tables
        ;-----------------------
        ;
        ;        org ((* + $ff) & $ff00)

doordatastart:  incbin bg\mw3door.dat

doorx           = doordatastart
doory           = doordatastart + 160
doorl           = doordatastart + 320
doord           = doordatastart + 480

sprrowtbl:      ds.b $22,$ff
                ds.b $08,$00
                ds.b $08,$01
                ds.b $08,$02
                ds.b $08,$03
                ds.b $08,$04
                ds.b $08,$05
                ds.b $08,$06
                ds.b $08,$07
                ds.b $08,$08
                ds.b $08,$09
                ds.b $08,$0a
                ds.b $08,$0b
                ds.b $08,$0c
                ds.b $08,$0d
                ds.b $08,$0e
                ds.b $08,$0f
                ds.b $08,$10
                ds.b $08,$11
                ds.b $08,$12
                ds.b $08,$13
                ds.b $03,$14
                ds.b $3b,$ff

coordtbllo:
N               set 0
                repeat 32
                dc.b <N
N               set N+32
                repend
N               set -32*32
                repeat 32
                dc.b <N
N               set N+32
                repend

coordtblhi:
N               set 0
                repeat 32
                dc.b >N
N               set N+32
                repend
N               set -32*32
                repeat 32
                dc.b >N
N               set N+32
                repend




        ;Technical routines (sprite, raster) data begins
        ;-----------------------------------------------

        ;RASTER.S data
        ;-------------

rasterroutlo:   dc.b <raster_gscreen
                dc.b <raster_panel
                dc.b <raster_panel2
                dc.b <raster_sprite
rasterrouthi:   dc.b >raster_gscreen
                dc.b >raster_panel
                dc.b >raster_panel2
                dc.b >raster_sprite
rasterpos:      dc.b RPOS_GSCREEN, RPOS_PANEL, RPOS_PANEL2, $50

gscrd018tbl:    dc.b SCREEN1_D018
                dc.b SCREEN2_D018

frameptrtbl:    dc.b #>(screen1+$3f8)
                dc.b #>(screen2+$3f8)

rspr_jumptbllo: dc.b <rspr_load7
                dc.b <rspr_load6
                dc.b <rspr_load5
                dc.b <rspr_load4
                dc.b <rspr_load3
                dc.b <rspr_load2
                dc.b <rspr_load1
                dc.b <rspr_load0

rspr_jumptblhi: dc.b >rspr_load7
                dc.b >rspr_load6
                dc.b >rspr_load5
                dc.b >rspr_load4
                dc.b >rspr_load3
                dc.b >rspr_load2
                dc.b >rspr_load1
                dc.b >rspr_load0

        ;SCREEN.S data
        ;-------------

cpr_tbl:        dc.b $01,$02,$03,$80
                dc.b $05,$06,$07,$84
                dc.b $09,$0a,$0b,$88
                dc.b $0d,$0e,$0f,$8c

cpd_tbl:        dc.b $04,$05,$06,$07
                dc.b $08,$09,$0a,$0b
                dc.b $0c,$0d,$0e,$0f
                dc.b $80,$81,$82,$83

scradrtblhi:    dc.b >screen1, >screen2

sw_shifttbllo:  dc.b <sw_shift1
                dc.b <sw_shift2
sw_shifttblhi:  dc.b >sw_shift1
                dc.b >sw_shift2

sw_shiftpostbl: dc.b 255,0,1,0
                dc.b 39,40,41,0
                dc.b 79,80,81

sw_shcoltbllo:  dc.b <sw_shcolupleft
                dc.b <sw_shcolup
                dc.b <sw_shcolupright
                dc.b <sw_donothing
                dc.b <sw_shcolleft
                dc.b <sw_donothing
                dc.b <sw_shcolright
                dc.b <sw_donothing
                dc.b <sw_shcoldownleft
                dc.b <sw_shcoldown
                dc.b <sw_shcoldownright
sw_shcoltblhi:  dc.b >sw_shcolupleft
                dc.b >sw_shcolup
                dc.b >sw_shcolupright
                dc.b >sw_donothing
                dc.b >sw_shcolleft
                dc.b >sw_donothing
                dc.b >sw_shcolright
                dc.b >sw_donothing
                dc.b >sw_shcoldownleft
                dc.b >sw_shcoldown
                dc.b >sw_shcoldownright

screenrowtbllo:
N               SET 0
                REPEAT 25
                dc.b #<(N*40)
N               SET N+1
                REPEND
screenrowtblhi:
N               SET 0
                REPEAT 25
                dc.b #>(N*40)
N               SET N+1
                REPEND

charanimroutlo: dc.b 0
                dc.b 0
                dc.b <chra_waterfall
                dc.b <chra_waterfall
                dc.b <chra_waterfall
                dc.b 0
                dc.b 0
                dc.b 0
                dc.b <chra_waterfall
                dc.b 0
                dc.b 0
                dc.b <chra_waterfall
                dc.b <chra_generator
                dc.b <chra_waterfall
                dc.b 0
                dc.b <chra_serverroom

charanimrouthi: dc.b 0
                dc.b 0
                dc.b >chra_waterfall
                dc.b >chra_waterfall
                dc.b >chra_waterfall
                dc.b 0
                dc.b 0
                dc.b 0
                dc.b >chra_waterfall
                dc.b 0
                dc.b 0
                dc.b >chra_waterfall
                dc.b >chra_generator
                dc.b >chra_waterfall
                dc.b 0
                dc.b >chra_serverroom
                dc.b 0
                dc.b 0

chra_gblinktbl: dc.b %01000100
                dc.b %01000111
                dc.b %01110100
                dc.b %01110111

scrollmultbl:   dc.b $38,$30,$28,$20,$18,$10,$08,$00
blockmultbl:    dc.b $00,$40,$80,$c0

        ;SPRITE.S data
        ;-------------

sprbittbl:      dc.b $80,$40,$20,$10,$08,$04,$02,$01
                dc.b $80,$40,$20,$10,$08,$04,$02,$01
                dc.b $80,$40,$20,$10,$08,$04,$02,$01
                dc.b $80,$40,$20,$10,$08,$04,$02,$01
                dc.b $80,$40,$20,$10,$08,$04,$02,$01
                dc.b $80,$40,$20,$10,$08,$04,$02,$01

sprlinesubtbl:  dc.b 3,4,5,6,7,8,9,10

sprontbl:       dc.b %00000000
                dc.b %10000000
                dc.b %11000000
                dc.b %11100000
                dc.b %11110000
                dc.b %11111000
                dc.b %11111100
                dc.b %11111110
                dc.b %11111111

        ;CONTROL.S data
        ;--------------

andbittbl:
keyrowbit:      dc.b $fe,$fd,$fb,$f7,$ef,$df,$bf,$7f
kcrownum:       dc.b 7,1,1,1,2,1,2,2,1,6
kcrowand:       dc.b $40,$02,$40,$04,$04,$10,$80,$10,$80,$10

kcjoybits:      dc.b JOY_LEFT+JOY_UP
                dc.b JOY_UP
                dc.b JOY_RIGHT+JOY_UP
                dc.b JOY_LEFT
                dc.b JOY_RIGHT
                dc.b JOY_LEFT+JOY_DOWN
                dc.b JOY_DOWN
                dc.b JOY_RIGHT+JOY_DOWN
                dc.b JOY_FIRE
                dc.b JOY_FIRE

asciitbl:       dc.b 255,13,0,0,0,0,0,0
                dc.b "3WA4ZSE",0
                dc.b "5RD6CFTX"
                dc.b "7YG8BHUV"
                dc.b "9IJ0MKON"
                dc.b 0,"PL",0,".",0,"@,"
                dc.b 0,0,0,0,0,0,0,"/"
                dc.b "1",0,0,"2 ",0,"Q",0




        ;Game content specific data begins
        ;---------------------------------

        ;LEVEL.S data
        ;------------

        ;Enemy generator 0 - Sub-City downtown

generatortbl:   dc.b ACT_GUNMAN,$00
                dc.b ACT_KNIFEMAN,$00
                dc.b ACT_BYSTANDER1,$04
                dc.b ACT_BYSTANDER1,$04

        ;Enemy generator 1 - Sub-City scum-infested areas

                dc.b ACT_GUNMAN,$00
                dc.b ACT_ANARCHIST,$00
                dc.b ACT_MOTORIST,$00
                dc.b ACT_BYSTANDER1,$04

        ;Enemy generator 2 - Desert

                dc.b ACT_GUNMAN,$08
                dc.b ACT_SHOTGUNMAN,$0c
                dc.b ACT_KNIFEMAN,$08
                dc.b ACT_MOTORIST,$0c

        ;Enemy generator 3 - The Outpost

                dc.b ACT_BYSTANDER1,$04
                dc.b ACT_BYSTANDER1,$04
                dc.b ACT_BYSTANDER1,$04
                dc.b ACT_BYSTANDER1,$04

        ;Enemy generator 4 - Free-City

                dc.b ACT_ANARCHIST,$00
                dc.b ACT_SHOTGUNMAN,$08
                dc.b ACT_MOTORIST,$08
                dc.b ACT_BYSTANDER1,$04

        ;Enemy generator 5 - Forest 2

                dc.b ACT_GUNMAN,$08
                dc.b ACT_ANARCHIST,$2c
                dc.b ACT_SHOTGUNMAN,$2c
                dc.b ACT_MOTORIST,$0c

        ;Enemy generator 6 - Dumpyard

                dc.b ACT_UZIMAN,$10
                dc.b ACT_SHOTGUNMAN,$10
                dc.b ACT_SHOTGUNMAN,$10
                dc.b ACT_GRENADEMAN,$10

        ;Enemy generator 7 - Asylum

                dc.b ACT_DOCTOR,$14
                dc.b ACT_DOCTOR,$14
                dc.b ACT_DOCTOR,$14
                dc.b ACT_DOCTOR,$14

        ;Enemy generator 8 - Toxic area

                dc.b ACT_MUTANTPIG,$18
                dc.b ACT_MUTANTRAT,$18
                dc.b ACT_AIRPLANE,$1c
                dc.b ACT_UZIMAN,$2c

        ;Enemy generator 9 - Toxic area 2

                dc.b ACT_GRENADEMAN,$2c
                dc.b ACT_MUTANTRAT,$18
                dc.b ACT_AIRPLANE,$0c
                dc.b ACT_UZIMAN,$2c

        ;Enemy generator 10 - Forest

                dc.b ACT_MUTANTRAT,$1c
                dc.b ACT_MUTANTRAT,$1c
                dc.b ACT_MUTANTRAT,$1c
                dc.b ACT_HAWK,$1c

        ;Enemy generator 11 - Base outdoors

                dc.b ACT_SOLDIER1,$20
                dc.b ACT_SOLDIER1,$20
                dc.b ACT_SOLDIER2,$20
                dc.b ACT_DOG,$20

        ;Enemy generator 12 - Flight scene

                dc.b ACT_ENEMYJETBIKE,$24
                dc.b ACT_ENEMYJETBIKE,$24
                dc.b ACT_ENEMYJETBIKE,$24
                dc.b ACT_ENEMYJETBIKE,$24

        ;Enemy generator 13 - The bridge

                dc.b ACT_GUNMAN,$2c
                dc.b ACT_KNIFEMAN,$08
                dc.b ACT_SHOTGUNMAN,$08
                dc.b ACT_MOTORIST,$2c

        ;Enemy generator 14 - CMC

                dc.b ACT_GUARD1,$28
                dc.b ACT_GUARD1,$28
                dc.b ACT_GUARD1,$28
                dc.b ACT_GUARD1,$28


        ;Probability tables - night, evening, morning, day

probabilitytbl: dc.b $40,$30,$08,$10    ;$00 - typical scum probability
                dc.b $20,$40,$60,$90    ;$04 - "decent people" probability
                dc.b $40,$50,$20,$40    ;$08 - scum outside cities
                dc.b $30,$40,$08,$20    ;$0c - rare scum outside cities
                dc.b $28,$30,$20,$38    ;$10 - scum in dumpyard
                dc.b $00,$28,$28,$40    ;$14 - doctors in asylum
                dc.b $80,$70,$70,$60    ;$18 - beasts
                dc.b $18,$30,$30,$24    ;$1c - animals in forest
                dc.b $38,$38,$38,$38    ;$20 - soldiers in the base
                dc.b $20,$20,$20,$20    ;$24 - jetbikes in flight scene
                dc.b $38,$38,$38,$38    ;$28 - guards in CMC building
                dc.b $50,$60,$30,$50    ;$2c - very scum-infested areas

        ;Door limit tables

doorlimitnum:   dc.b 4                  ;Guns'n'Ammo (Sub-City)
                dc.b 7                  ;Iron Gym (Sub-City)
                dc.b 97                 ;Hades Club (Sub-City)
                dc.b 100                ;Bar (Sub-City)
                dc.b 102                ;Axes'n Amps (Sub-City)
                dc.b 112                ;Power Gym (Freecity)
                dc.b 115                ;Mortuary (Freecity)
                dc.b 118                ;Sodoma (Freecity)
                dc.b 119                ;Sodoma (Freecity)
                dc.b 121                ;Guns (Freecity)
                dc.b 123                ;Bar (Freecity)
                dc.b 125                ;Police Station (Sub-City)
                dc.b 129                ;Guns (Metro City)
                dc.b 128                ;Extreme Gym (Metro City)
                dc.b 131                ;Chrome Club (Metro City)
                dc.b 152                ;Asylum
                dc.b 134                ;Guns (Outpost)
                dc.b 136                ;Tavern (Outpost)
                dc.b 77                 ;CMC (Metro City)
                dc.b 78                 ;CMC (Metro City)
                dc.b 79                 ;CMC (Metro City)
                dc.b 80                 ;CMC (Metro City)
                dc.b 19                 ;Control room in factory
                dc.b 36                 ;Cell in army base
                dc.b 38                 ;Cell in army base
                dc.b 40                 ;Cell in army base
                dc.b 34                 ;Helipad door in army base
                dc.b 105                ;Home of I & P
                dc.b 106                ;Home of I & P
                dc.b 86                 ;CMC door #1
                dc.b 88                 ;CMC door #2
                dc.b 90                 ;CMC door #3
                dc.b 92                 ;CMC final door
                dc.b $ff                ;End of list

doorlimitlow:   dc.b $08                ;Guns'n'Ammo (Sub-City)
                dc.b $08                ;Iron Gym (Sub-City)
                dc.b $12                ;Hades Club (Sub-City)
                dc.b $12                ;Bar (Sub-City)
                dc.b $08                ;Axes'n Amps (Sub-City)
                dc.b $08                ;Power Gym (Freecity)
                dc.b $12                ;Mortuary (Freecity)
                dc.b $12                ;Sodoma (Freecity)
                dc.b $12                ;Sodoma (Freecity)
                dc.b $08                ;Guns (Freecity)
                dc.b $12                ;Bar (Freecity)
                dc.b $06                ;Police Station (Sub-City)
                dc.b $08                ;Guns (Metro City)
                dc.b $08                ;Extreme Gym (Metro City)
                dc.b $12                ;Chrome Club (Metro City)
                dc.b $08                ;Asylum
                dc.b $08                ;Guns (Outpost)
                dc.b $08                ;Tavern (Outpost)
                dc.b $08                ;CMC (Metro City)
                dc.b $08                ;CMC (Metro City)
                dc.b $08                ;CMC (Metro City)
                dc.b $08                ;CMC (Metro City)
                dc.b $80                ;Control room in factory (KEY!)
                dc.b $80                ;Cell in army base (KEY!)
                dc.b $80                ;Cell in army base (KEY!)
                dc.b $80                ;Cell in army base (KEY!)
                dc.b $81                ;Helipad door in army base (KEYCARD!)
                dc.b $80                ;Home of I & P (KEY!)
                dc.b $80                ;Home of I & P (KEY!)
                dc.b $81                ;CMC door #1 (KEYCARD!)
                dc.b $81                ;CMC door #2 (KEYCARD!)
                dc.b $81                ;CMC door #3 (KEYCARD!)
                dc.b $80                ;CMC final door

doorlimithigh:  dc.b $20                ;Guns'n'Ammo (Sub-City)
                dc.b $22                ;Iron Gym (Sub-City)
                dc.b $04                ;Hades Club (Sub-City)
                dc.b $04                ;Bar (Sub-City)
                dc.b $20                ;Axes'n Amps (Sub-City)
                dc.b $22                ;Power Gym (Freecity)
                dc.b $04                ;Mortuary (Freecity)
                dc.b $04                ;Sodoma (Freecity)
                dc.b $04                ;Sodoma (Freecity)
                dc.b $20                ;Guns (Freecity)
                dc.b $04                ;Bar (Freecity)
                dc.b $22                ;Police Station (Sub-City)
                dc.b $20                ;Guns (Metro City)
                dc.b $22                ;Extreme Gym (Metro City)
                dc.b $04                ;Chrome Club (Metro City)
                dc.b $98                ;Asylum
                dc.b $20                ;Guns (Outpost)
                dc.b $04                ;Tavern (Outpost)
                dc.b $a0                ;CMC (Metro City)
                dc.b $a0                ;CMC (Metro City)
                dc.b $a0                ;CMC (Metro City)
                dc.b $a0                ;CMC (Metro City)
                dc.b ITEM_CTRLROOMKEY   ;Control room in factory
                dc.b ITEM_CELLKEY       ;Cell in army base (KEY!)
                dc.b ITEM_CELLKEY       ;Cell in army base (KEY!)
                dc.b ITEM_CELLKEY       ;Cell in army base (KEY!)
                dc.b ITEM_HELIPADCARD   ;Helipad door in army base (KEYCARD!)
                dc.b ITEM_APARTMENTKEY  ;Home of I & P (KEY!)
                dc.b ITEM_APARTMENTKEY  ;Home of I & P (KEY!)
                dc.b ITEM_KEYCARD       ;CMC door #1 (KEYCARD!)
                dc.b ITEM_SRKEYCARD     ;CMC door #2 (KEYCARD!)
                dc.b ITEM_LABKEYCARD    ;CMC door #3 (KEYCARD!)
                dc.b $00                ;CMC final door

musicbanktbl:   dc.b $ff,$ff,$ff,$00,$01,$01,$02,$02,$03,$03,$04,$04,$05,$05,$05,$06
musicindextbl:  dc.b $01,$02,$03,$04,$04,$05,$04,$05,$04,$05,$04,$05,$04,$05,$06,$04

levelsprtbl:    dc.b 7,8,7,7,10,9,9,7,10,10,7,9,9,7,7,11,8,11
leveltunetbl:   dc.b MUSIC_CITY
                dc.b MUSIC_INSIDE
                dc.b MUSIC_DESERT
                dc.b MUSIC_DESERT
                dc.b MUSIC_FOREST
                dc.b MUSIC_NINJA
                dc.b MUSIC_EXPLORE
                dc.b MUSIC_CITY
                dc.b MUSIC_NINJA
                dc.b MUSIC_EXPLORE
                dc.b MUSIC_DESERT
                dc.b MUSIC_NINJA
                dc.b MUSIC_FOREST
                dc.b MUSIC_NINJA
                dc.b MUSIC_CITY
                dc.b MUSIC_EXPLORE
                dc.b MUSIC_INSIDE
                dc.b MUSIC_FLIGHT

        ;WEAPON.S data
        ;-------------

weapxspdtbl:    dc.b 8*8,8*8,8*8,8*8,4*8,8*8,6*8,8*8,8*8,3*8
                dc.b 4*8,10*8,15*8,6*8,10*8,3*8
weapyspdtbl:    dc.b 0,-6,0,0,0,0,0,6,0,-28
                dc.b -6*8,-8*8,-8*8,-6*8,-8*8,-28
weapandtbl:     dc.b 7,7,7,0,7,3,0,7,7,0
                dc.b 0,0,0,0,0,0
weapsndtbl:     dc.b SFX_SHOOT2,SFX_SHOOT3,SFX_SHOOT1,SFX_FLAME,SFX_SHOOT3,SFX_SHOOT4,SFX_SHOOT4,0,0,0
                dc.b 0,0,0,0,0,SFX_MELEE
weapacttbl:     dc.b ACT_BULLET,ACT_BULLET,ACT_BULLET,ACT_FLAME,ACT_MISSILE,ACT_LASER,ACT_PLASMA,ACT_BULLET,ACT_BULLET,ACT_GRENADE
                dc.b ACT_MELEEHIT,ACT_MELEEHIT,ACT_MELEEHIT,ACT_MELEEHIT,ACT_MELEEHIT,ACT_MOLOTOV
weapdmgtbl:     dc.b DMG_BULLET,DMG_SHOTGUN,DMG_BULLET,DMG_FLAME,DMG_MISSILE,DMG_LASER,DMG_PLASMA,DMG_SHOTGUN,DMG_SHOTGUN,0
                dc.b DMG_FIST,DMG_WHIP,DMG_WHIP,DMG_KNIFE,DMG_NUNCHAKU,0
weapnexttbl:    dc.b -1,BLT_SHOTGUN2,-1,-1,-1,-1,-1,BLT_SHOTGUN3,-1,-1
                dc.b -1,BLT_WHIPHIT2,-1,-1,-1,-1
weapdelaytbl:   dc.b 16,24,5,4,16,4,12,0,0,MELEEDELAY
                dc.b MELEEDELAY,MELEEDELAY,MELEEDELAY,MELEEDELAY,MELEEDELAY,MELEEDELAY

        ;ACTOR.S data
        ;------------

itemflashcoltbl:dc.b 15,7,1,7

athotspotx:     dc.b 12,12,12,24                        ;Player
                dc.b 12                                 ;Items
                dc.b 24                                 ;Player on jetbike

                dc.b 12,12,12,24                        ;Enemies
                dc.b 12,12,12,12
                dc.b 12,24,12,12
                dc.b 12,12,12,12
                dc.b 24,48,12,12
                dc.b 36,12

                dc.b 12,12,12,12                        ;Bystanders
                dc.b 12
                dc.b 8                                  ;"Flame"
                dc.b 48                                 ;Truck
                dc.b 24                                 ;Jetbike

                dc.b 12                                 ;Shopkeeper
                dc.b 12,12,12,12                        ;"Customers"
                dc.b 12,12,12,12
                dc.b 12,12,12,12
                dc.b 36,36,36                           ;Bands
                dc.b 12                                 ;Robot :-)
                dc.b 12,12,12,8                         ;NPCs
                dc.b 8
                dc.b 12,12,12,12
                dc.b 24,24,24,24                        ;Knocked out enemies
                dc.b 24,24,24,24
                dc.b 12,24,12,24
                dc.b 12,12,24,48
                dc.b 24,24,36,24

                dc.b 12,12                              ;Explosion

athotspoty:     dc.b 40,30,40,11                        ;Player
                dc.b 11                                 ;Items
                dc.b 20                                 ;Player on jetbike

                dc.b 40,40,40,40                        ;Enemies
                dc.b 40,40,40,40
                dc.b 20,36,15,40
                dc.b 40,15,10,21
                dc.b 20,21,40,40
                dc.b 40,40

                dc.b 40,40,40,40                        ;Bystanders
                dc.b 40
                dc.b 20                                 ;"Flame"
                dc.b 53                                 ;Truck
                dc.b 19                                 ;Jetbike

                dc.b 39                                 ;Shopkeeper
                dc.b 36,36,36,36                        ;"Customers"
                dc.b 36,36,36,36
                dc.b 36,36,36,36
                dc.b 37,37,37                           ;Bands
                dc.b 38                                 ;Robot :-)
                dc.b 32,36,36,31                        ;NPCs
                dc.b 31
                dc.b 39,39,39,39

                dc.b 11,11,11,11                        ;Knocked out enemies
                dc.b 11,11,11,11
                dc.b 20,11,12,11
                dc.b 15,15,20,21
                dc.b 11,11,25,11
                dc.b 10,20                              ;Explosion

atrightframe:   dc.b 9,1,0,2                            ;Player
                dc.b 0                                  ;Items
                dc.b 0                                  ;Player on jetbike

                dc.b 10,9,8,1                            ;Enemies
                dc.b 8,10,8,9
                dc.b 3,2,3,10
                dc.b 8,4,4,1
                dc.b 0,0,10,8
                dc.b 0,8
                dc.b 6,6,6,6                            ;Bystanders
                dc.b 6
                dc.b 0                                  ;"Flame"
                dc.b 0                                  ;Truck
                dc.b 0                                  ;Jetbike

                dc.b 0                                  ;Shopkeeper
                dc.b 0,0,0,0                            ;"Customers"
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,0,0                              ;Bands
                dc.b 0                                  ;Robot :-)
                dc.b 0,0,0,0                            ;NPCs
                dc.b 0
                dc.b 0,0,0,0
                dc.b 2,2,2,2                            ;Knocked out enemies
                dc.b 2,2,2,2
                dc.b 2,2,2,2
                dc.b 2,2,0,0
                dc.b 2,2,0,2
                dc.b 0,0                                ;Explosion
                dc.b 248,242,229,237                    ;Bullets
                dc.b 241,247,228,227

atsizeu:        dc.b 36,24,36,8                         ;Player
                dc.b 8                                  ;Items
                dc.b 18                                 ;Player on jetbike

                dc.b 36,36,36,36                        ;Enemies
                dc.b 36,36,36,36
                dc.b 19,30,10,36
                dc.b 36,12,6,16
                dc.b 20,21,36,36
                dc.b 42,36
                dc.b 36,36,36,36                        ;Bystanders
                dc.b 36
                dc.b 0                                  ;"Flame"
                dc.b 58                                 ;Truck
                dc.b 8                                  ;Jetbike
                dc.b 40                                 ;Shopkeeper
                dc.b 28,28,28,28                        ;"Customers"
                dc.b 28,28,28,28
                dc.b 28,28,28,28
                dc.b 0,0,0                              ;Bands
                dc.b 0                                  ;Robot :-)
                dc.b 28,28,28,28                        ;NPCs
                dc.b 28
                dc.b 40,40,40,40
                dc.b 8,8,8,8                            ;Knocked out enemies
                dc.b 8,8,8,8
                dc.b 15,8,6,8
                dc.b 12,6,20,21
                dc.b 8,8,25,8
                dc.b 24,16                              ;Explosion

atsized:        dc.b 0,0,0,0                            ;Player
                dc.b 0                                  ;Items
                dc.b 0                                  ;Player on jetbike
                dc.b 0,0,0,0                            ;Enemies
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,0,6,0
                dc.b 0,21,0,0
                dc.b 0,0
                dc.b 0,0,0,0                            ;Bystanders
                dc.b 0
                dc.b 0                                  ;"Flame"
                dc.b 0                                  ;Truck
                dc.b 0                                  ;Jetbike
                dc.b 0                                  ;Shopkeeper
                dc.b 0,0,0,0                            ;"Customers"
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,0,0                              ;Bands
                dc.b 0                                  ;Robot :-)
                dc.b 0,0,0,0                            ;NPCs
                dc.b 0
                dc.b 0,0,0,0
                dc.b 0,0,0,0                            ;Knocked out enemies
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,6,0,21
                dc.b 0,0,15,0
                dc.b 24,0                               ;Explosion

atsizeh:        dc.b 10,10,10,24                        ;Player
                dc.b 8                                  ;Items
                dc.b 20                                 ;Player on jetbike

                dc.b 10,10,10,22                        ;Enemies
                dc.b 10,10,10,10
                dc.b 10,24,8,10
                dc.b 10,10,8,10
                dc.b 20,48,10,10
                dc.b 32,10
                dc.b 10,10,10,10                        ;Bystanders
                dc.b 10
                dc.b 0                                  ;"Flame"
                dc.b 48                                 ;Truck
                dc.b 8                                  ;Jetbike
                dc.b 10                                 ;Shopkeeper
                dc.b 16,16,16,16                        ;"Customers"
                dc.b 16,16,16,16
                dc.b 16,16,16,16
                dc.b 0,0,0                              ;Bands
                dc.b 0                                  ;Robot :-)
                dc.b 16,16,16,16                        ;NPCs
                dc.b 16
                dc.b 10,10,10,10
                dc.b 24,24,24,24                        ;Knocked out enemies
                dc.b 24,24,24,24
                dc.b 12,24,8,24
                dc.b 10,8,20,48
                dc.b 24,24,32,24
                dc.b 48,8                               ;Explosion

atformlo:       dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_2x1 ;Player
                dc.b <doact_1x1                                  ;Items
                dc.b <doact_2x1                                  ;Player on jetbike
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_2x2 ;Enemies
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_1x2
                dc.b <doact_1x1,<doact_2x2,<doact_1x1,<doact_1x2
                dc.b <doact_1x2,<doact_1x1,<doact_1x1,<doact_1x1
                dc.b <doact_2x1,<doact_4x2,<doact_1x2,<doact_1x2
                dc.b <doact_3x2,<doact_1x2
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_1x2 ;Bystanders
                dc.b <doact_1x2
                dc.b <doact_1x1                                  ;"Flame"
                dc.b <doact_4x3                                  ;Truck
                dc.b <doact_2x1                                  ;Jetbike
                dc.b <doact_1x1                                  ;Shopkeeper
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_1x2 ;"Customers"
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_1x2
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_1x2
                dc.b <doact_3x2,<doact_3x2,<doact_3x2
                dc.b <doact_1x2
                dc.b <doact_1x2,<doact_1x2,<doact_1x2,<doact_1x1 ;NPCs
                dc.b <doact_1x1
                dc.b <doact_1x1,<doact_1x1,<doact_1x1,<doact_1x1
                dc.b <doact_2x1,<doact_2x1,<doact_2x1,<doact_2x1 ;Knocked out enemies
                dc.b <doact_2x1,<doact_2x1,<doact_2x1,<doact_2x1
                dc.b <doact_1x1,<doact_2x1,<doact_1x1,<doact_2x1
                dc.b <doact_1x1,<doact_1x1,<doact_2x1,<doact_4x2
                dc.b <doact_2x1,<doact_2x1,<doact_3x2,<doact_2x1
                dc.b <doact_1x1,<doact_1x1                       ;Explosion

atformhi:       dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_2x1 ;Player
                dc.b >doact_1x1                                  ;Items
                dc.b >doact_2x1                                  ;Player on jetbike
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_2x2 ;Enemies
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_1x2
                dc.b >doact_1x1,>doact_2x2,>doact_1x1,>doact_1x2
                dc.b >doact_1x2,>doact_1x1,>doact_1x1,>doact_1x1
                dc.b >doact_2x1,>doact_4x2,>doact_1x2,>doact_1x2
                dc.b >doact_3x2,>doact_1x2
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_1x2 ;Bystanders
                dc.b >doact_1x2
                dc.b >doact_1x1                                  ;"Flame"
                dc.b >doact_4x3                                  ;Truck
                dc.b >doact_2x1                                  ;Jetbike
                dc.b >doact_1x1                                  ;Shopkeeper
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_1x2 ;"Customers"
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_1x2
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_1x2
                dc.b >doact_3x2,>doact_3x2,>doact_3x2
                dc.b >doact_1x2
                dc.b >doact_1x2,>doact_1x2,>doact_1x2,>doact_1x1 ;NPCs
                dc.b >doact_1x1
                dc.b >doact_1x1,>doact_1x1,>doact_1x1,>doact_1x1
                dc.b >doact_2x1,>doact_2x1,>doact_2x1,>doact_2x1 ;Knocked out enemies
                dc.b >doact_2x1,>doact_2x1,>doact_2x1,>doact_2x1
                dc.b >doact_1x1,>doact_2x1,>doact_1x1,>doact_2x1
                dc.b >doact_1x1,>doact_1x1,>doact_2x1,>doact_4x2
                dc.b >doact_2x1,>doact_2x1,>doact_3x2,>doact_2x1
                dc.b >doact_1x1,>doact_1x1                       ;Explosion
                dc.b 0,0,0,0,0,0,0,0                             ;Bullets

atframelo:      dc.b <fr_plrrun,<fr_plrduck,<fr_plrclimb,<fr_plrout
                dc.b <fr_item
                dc.b <fr_playerjetbike
                dc.b <fr_gunman,<fr_knifeman,<fr_anarchist,<fr_motorist
                dc.b <fr_shotgunman,<fr_uziman,<fr_anarchist,<fr_gangleader
                dc.b <fr_mutantpig,<fr_airplane,<fr_mutantrat,<fr_uziman
                dc.b <fr_soldier2,<fr_dog,<fr_hawk,<fr_towergunner
                dc.b <fr_enemyjetbike,<fr_helicopter,<fr_guard1,<fr_guard2
                dc.b <fr_bigrobot,<fr_general
                dc.b <fr_bystander1,<fr_bystander2,<fr_bystander3,<fr_bystander4
                dc.b <fr_doctor
                dc.b <fr_groundflame
                dc.b <fr_truck
                dc.b <fr_jetbike
                dc.b <fr_shopkeeper
                dc.b <fr_customer1,<fr_customer2,<fr_customer3,<fr_customer4
                dc.b <fr_customer5,<fr_customer6,<fr_customer6,<fr_customer8
                dc.b <fr_customer8,<fr_customer4,<fr_scientist,<fr_bofh
                dc.b <fr_band1, <fr_band2, <fr_band3
                dc.b <fr_sexrobot
                dc.b <fr_hammer, <fr_snake, <fr_ultrashred, <fr_colonel
                dc.b <fr_prisonkeeper
                dc.b <fr_worker1,<fr_worker2,<fr_worker3,<fr_worker4
                dc.b <fr_gunmanout,<fr_knifemanout,<fr_anarchistout,<fr_motoristout
                dc.b <fr_shotgmanout,<fr_gunmanout,<fr_anarchistout,<fr_gangleaderout
                dc.b <fr_mutantpigout,<fr_gunmanout,<fr_mutantratout,<fr_soldier2out
                dc.b <fr_dogout,<fr_hawkout,<fr_jetbikeout,<fr_helicopterout
                dc.b <fr_guard1out,<fr_guard2out,<fr_bigrobotout,<fr_generalout
                dc.b <fr_explosion,<fr_groundflame

atframehi:      dc.b >fr_plrrun,>fr_plrduck,>fr_plrclimb,>fr_plrout
                dc.b >fr_item
                dc.b >fr_playerjetbike
                dc.b >fr_gunman,>fr_knifeman,>fr_anarchist,>fr_motorist
                dc.b >fr_shotgunman,>fr_uziman,>fr_anarchist,>fr_gangleader
                dc.b >fr_mutantpig,>fr_airplane,>fr_mutantrat,>fr_uziman
                dc.b >fr_soldier2,>fr_dog,>fr_hawk,>fr_towergunner
                dc.b >fr_enemyjetbike,>fr_helicopter,>fr_guard1,>fr_guard2
                dc.b >fr_bigrobot,>fr_general
                dc.b >fr_bystander1,>fr_bystander2,>fr_bystander3,>fr_bystander4
                dc.b >fr_doctor
                dc.b >fr_groundflame
                dc.b >fr_truck
                dc.b >fr_jetbike
                dc.b >fr_shopkeeper
                dc.b >fr_customer1,>fr_customer2,>fr_customer3,>fr_customer4
                dc.b >fr_customer5,>fr_customer6,>fr_customer6,>fr_customer8
                dc.b >fr_customer8,>fr_customer4,>fr_scientist,>fr_bofh
                dc.b >fr_band1, >fr_band2, >fr_band3
                dc.b >fr_sexrobot
                dc.b >fr_hammer, >fr_snake, >fr_ultrashred, >fr_colonel
                dc.b >fr_prisonkeeper
                dc.b >fr_worker1,>fr_worker2,>fr_worker3,>fr_worker4
                dc.b >fr_gunmanout,>fr_knifemanout,>fr_anarchistout,>fr_motoristout
                dc.b >fr_shotgmanout,>fr_gunmanout,>fr_anarchistout,>fr_gangleaderout
                dc.b >fr_mutantpigout,>fr_gunmanout,>fr_mutantratout,>fr_soldier2out
                dc.b >fr_dogout,>fr_hawkout,>fr_jetbikeout,>fr_helicopterout
                dc.b >fr_guard1out,>fr_guard2out,>fr_bigrobotout,>fr_generalout
                dc.b >fr_explosion,>fr_groundflame

atroutlo:       dc.b <ar_plrrun,<ar_plrduck,<ar_plrclimb,<ar_enemyout
                dc.b <ar_item
                dc.b <ar_playerjetbike
                dc.b <ar_gunman,<ar_knifeman,<ar_anarchist,<ar_motorist
                dc.b <ar_shotgunman,<ar_uziman,<ar_grenademan,<ar_gangleader
                dc.b <ar_mutantpig,<ar_airplane,<ar_mutantrat,<ar_soldier1
                dc.b <ar_soldier2,<ar_dog,<ar_hawk,<ar_towergunner
                dc.b <ar_enemyjetbike,<ar_helicopter,<ar_guard1,<ar_guard2
                dc.b <ar_bigrobot,<ar_general
                dc.b <ar_bystander,<ar_bystander,<ar_bystander,<ar_bystander
                dc.b <ar_doctor
                dc.b <ar_introflame
                dc.b <ar_truck
                dc.b <ar_jetbike
                dc.b <ar_shopkeeper
                dc.b <ar_customer,<ar_customer,<ar_customer,<ar_customer
                dc.b <ar_customer,<ar_customer,<ar_customer,<ar_customer
                dc.b <ar_customer,<ar_customer,<ar_customer,<ar_customer
                dc.b <ar_band,<ar_band,<ar_band
                dc.b <ar_sexrobot
                dc.b <ar_npc,<ar_npc,<ar_npc,<ar_militarynpc
                dc.b <ar_militarynpc
                dc.b <ar_militarynpc2,<ar_militarynpc2,<ar_militarynpc2,<ar_militarynpc2
                dc.b <ar_enemyout,<ar_enemyout,<ar_enemyout,<ar_motoristout
                dc.b <ar_enemyout,<ar_enemyout,<ar_enemyout,<ar_enemyout
                dc.b <ar_enemyout,<ar_pilotout,<ar_enemyout,<ar_enemyout
                dc.b <ar_enemyout,<ar_enemyout,<ar_jetbikeout,<ar_helicopterout
                dc.b <ar_enemyout,<ar_enemyout,<ar_bigrobotout,<ar_generalout
                dc.b <ar_explosion,<ar_groundflame
                dc.b <ar_bullet,<ar_flame,<ar_missile,<ar_laser
                dc.b <ar_plasma,<ar_grenade,<ar_meleehit,<ar_molotov

atrouthi:       dc.b >ar_plrrun,>ar_plrduck,>ar_plrclimb,>ar_enemyout
                dc.b >ar_item
                dc.b >ar_playerjetbike
                dc.b >ar_gunman,>ar_knifeman,>ar_anarchist,>ar_motorist
                dc.b >ar_shotgunman,>ar_uziman,>ar_grenademan,>ar_gangleader
                dc.b >ar_mutantpig,>ar_airplane,>ar_mutantrat,>ar_soldier1
                dc.b >ar_soldier2,>ar_dog,>ar_hawk,>ar_towergunner
                dc.b >ar_enemyjetbike,>ar_helicopter,>ar_guard1,>ar_guard2
                dc.b >ar_bigrobot,>ar_general
                dc.b >ar_bystander,>ar_bystander,>ar_bystander,>ar_bystander
                dc.b >ar_doctor
                dc.b >ar_introflame
                dc.b >ar_truck
                dc.b >ar_jetbike
                dc.b >ar_shopkeeper
                dc.b >ar_customer,>ar_customer,>ar_customer,>ar_customer
                dc.b >ar_customer,>ar_customer,>ar_customer,>ar_customer
                dc.b >ar_customer,>ar_customer,>ar_customer,>ar_customer
                dc.b >ar_band,>ar_band,>ar_band
                dc.b >ar_sexrobot
                dc.b >ar_npc,>ar_npc,>ar_npc,>ar_militarynpc
                dc.b >ar_militarynpc
                dc.b >ar_militarynpc2,>ar_militarynpc2,>ar_militarynpc2,>ar_militarynpc2
                dc.b >ar_enemyout,>ar_enemyout,>ar_enemyout,>ar_motoristout
                dc.b >ar_enemyout,>ar_enemyout,>ar_enemyout,>ar_enemyout
                dc.b >ar_enemyout,>ar_pilotout,>ar_enemyout,>ar_enemyout
                dc.b >ar_enemyout,>ar_enemyout,>ar_jetbikeout,>ar_helicopterout
                dc.b >ar_enemyout,>ar_enemyout,>ar_bigrobotout,>ar_generalout
                dc.b >ar_explosion,>ar_groundflame
                dc.b >ar_bullet,>ar_flame,>ar_missile,>ar_laser
                dc.b >ar_plasma,>ar_grenade,>ar_meleehit,>ar_molotov

        ;These tables only for actors who can shoot

atyaddlo:       dc.b <(-20*8),<(-12*8),0,0      ;Player
                dc.b 0                          ;Items
                dc.b <(-4*8)                    ;Player on jetbike
                dc.b <(-28*8),<(-16*8),<(-24*8),0 ;Enemies
                dc.b <(-20*8),<(-28*8),<(-24*8),<(-20*8)
                dc.b 0,<(-8*8),0,<(-28*8)
                dc.b <(-20*8),0,0,<(-4*8)
                dc.b <(-4*8),<(16*8),<(-28*8),<(-20*8)
                dc.b <(-8*8),<(-20*8)

atyaddhi:       dc.b >(-20*8),>(-12*8),0,0      ;Player
                dc.b 0                          ;Items
                dc.b >(-4*8)                    ;Player on jetbike
                dc.b >(-28*8),>(-16*8),>(-24*8),0 ;Enemies
                dc.b >(-20*8),>(-28*8),>(-24*8),>(-20*8)
                dc.b 0,>(-8*8),0,>(-28*8)
                dc.b >(-20*8),0,0,>(-4*8)
                dc.b >(-4*8),>(16*8),>(-28*8),>(-20*8)
                dc.b >(-8*8),>(-20*8)

atxaddlo:       dc.b <6*8,<6*8,0,0              ;Player
                dc.b 0                          ;Items
                dc.b <12*8                      ;Player on jetbike
                dc.b <6*8,<6*8,<6*8,0           ;Enemies
                dc.b <6*8,<6*8,<6*8,<6*8
                dc.b 0,<8*8,0,<6*8
                dc.b <6*8,0,0,<6*8
                dc.b <(12*8),<(48*8),<6*8,<6*8
                dc.b <(24*8),<6*8

atxaddhi:       dc.b >6*8,>6*8,0,0              ;Player
                dc.b 0                          ;Items
                dc.b >12*8                      ;Player on jetbike
                dc.b >6*8,>6*8,>6*8,0           ;Enemies
                dc.b >6*8,>6*8,>6*8,>6*8
                dc.b 0,>8*8,0,>6*8
                dc.b >6*8,0,0,>6*8
                dc.b >(12*8),>(48*8),>6*8,>6*8
                dc.b >(24*8),>6*8

atdmgbonus:     dc.b 0,0,0,0                    ;Player
                dc.b 0                          ;Items
                dc.b 0,1,0,0                    ;Enemies
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,0

        ;These tables for actors who take damage

atout:          dc.b ACT_PLROUT,ACT_PLROUT,ACT_PLROUT,0 ;Player
                dc.b 0                                  ;Items
                dc.b ACT_PLRJETBIKE
                dc.b ACT_GUNMANOUT,ACT_KNIFEMANOUT,ACT_ANARCHISTOUT,ACT_MOTORISTOUT  ;Enemies
                dc.b ACT_SHOTGMANOUT,ACT_UZIMANOUT,ACT_ANARCHISTOUT,ACT_GANGLEADEROUT
                dc.b ACT_MUTANTPIGOUT,ACT_PILOTOUT,ACT_MUTANTRATOUT,ACT_UZIMANOUT
                dc.b ACT_SOLDIER2OUT,ACT_DOGOUT,ACT_HAWKOUT,ACT_UZIMANOUT
                dc.b ACT_JETBIKEOUT,ACT_HELICOPTEROUT,ACT_GUARD1OUT,ACT_GUARD2OUT
                dc.b ACT_BIGROBOTOUT,ACT_GENERALOUT

atoutymod:      dc.b -15*8,-15*8,-15*8,0                ;Player
                dc.b 0                                  ;Items
                dc.b 0*8                                ;Player on jetbike
                dc.b -15*8,-15*8,-15*8,-15*8            ;Enemies
                dc.b -15*8,-15*8,-15*8,-15*8
                dc.b -2*8,-15*8,-5*8,-15*8
                dc.b -15*8,-2*8,-4*8,-4*8
                dc.b 0*8,0*8,-15*8,-15*8
                dc.b -15*8,-15*8

atarmor:        dc.b 0,0,0,0                            ;Player
                dc.b 0                                  ;Items
                dc.b 5                                  ;Player on jetbike
                dc.b 0,0,0,0                            ;Enemies
                dc.b 0,0,0,5
                dc.b 0,0,0,0
                dc.b 0,0,0,0
                dc.b 0,5,0,0
                dc.b 6,5

        ;These tables only for enemies

enemydefaulthp: dc.b 8,8,6,14                   ;Enemies
                dc.b 10,10,12,64
                dc.b 8,16,2,14
                dc.b 16,8,2,16
                dc.b 16,128,16,20
                dc.b 144,128

enemyjumpframe: dc.b 6,6,6,0
                dc.b 6,6,6,6
                dc.b 2,0,2,6
                dc.b 6,2,0,0
                dc.b 0,0,6,6
                dc.b 0,6

                dc.b 2,2,2,2
                dc.b 2

enemyjumpspeed: dc.b -22,-22,-22,-1*8
                dc.b -20,0,-21,-20
                dc.b -18,0,-19,0
                dc.b 0,-16,0,0
                dc.b 0,0,0,0
                dc.b -24,-20

                dc.b 0,0,0,0
                dc.b 0

enemyfollow:    dc.b 0,0,0,0
                dc.b 0,1,0,1
                dc.b 0,0,0,1
                dc.b 1,1,0,0
                dc.b 0,0,1,1
                dc.b 0,1

                dc.b 0,0,0,0
                dc.b 0

enemyscore:     dc.b SCORE_500,SCORE_350,SCORE_750,SCORE_1000
                dc.b SCORE_1500,SCORE_2500,SCORE_1500,SCORE_50000
                dc.b SCORE_1500,SCORE_2500,SCORE_500,SCORE_2500
                dc.b SCORE_2500,SCORE_750,SCORE_350,SCORE_5000
                dc.b SCORE_1500,SCORE_50000,SCORE_2500,SCORE_5000
                dc.b SCORE_50000,SCORE_100000

enemygroundcheck:dc.b CI_GROUND,CI_GROUND,CI_GROUND,CI_GROUND
                dc.b CI_GROUND,CI_GROUND,CI_GROUND,CI_GROUND
                dc.b CI_GROUND,0,CI_GROUND,CI_GROUND
                dc.b CI_GROUND,CI_GROUND,0,0
                dc.b 0,0,CI_GROUND,CI_GROUND
                dc.b CI_GROUND,CI_GROUND
                dc.b CI_GROUND,CI_GROUND,CI_GROUND,CI_GROUND
                dc.b CI_GROUND

enemyitemindex: dc.b 1,4,8,9
                dc.b 12,15,19,$80
                dc.b 23,27,23,31
                dc.b 34,0,23,0
                dc.b 0,0,$81,41
                dc.b $82,$83

enemyitemtbl:   dc.b ITEM_PISTOL                ;1 Gunman
                dc.b ITEM_PISTOL                ;2
                dc.b ITEM_CREDITS               ;3
                dc.b ITEM_MEDIKIT               ;4 Knifeman
                dc.b ITEM_CREDITS               ;5
                dc.b ITEM_KNIFE                 ;6
                dc.b ITEM_KNIFE                 ;7
                dc.b ITEM_CREDITS               ;8 Anarchist
                dc.b ITEM_CREDITS               ;9 Motorist
                dc.b ITEM_CREDITS               ;10
                dc.b ITEM_CREDITS               ;11
                dc.b ITEM_MEDIKIT               ;12 Shotgunman
                dc.b ITEM_SHOTGUN               ;13
                dc.b ITEM_SHOTGUN               ;14
                dc.b ITEM_CREDITS               ;15 Uziman
                dc.b ITEM_SMG                   ;16
                dc.b ITEM_SMG                   ;17
                dc.b ITEM_MEDIKIT               ;18
                dc.b ITEM_GRENADES              ;19 Grenademan
                dc.b ITEM_MEDIKIT               ;20
                dc.b ITEM_CREDITS               ;21
                dc.b ITEM_CREDITS               ;22
                dc.b ITEM_FOOD                  ;23 Animals :-)
                dc.b ITEM_FOOD                  ;24
                dc.b ITEM_NONE                  ;25
                dc.b ITEM_NONE                  ;26
                dc.b ITEM_MEDIKIT               ;27 Airplane
                dc.b ITEM_MEDIKIT               ;28
                dc.b ITEM_CREDITS               ;29
                dc.b ITEM_CREDITS               ;30
                dc.b ITEM_SMG                   ;31 Soldier 1
                dc.b ITEM_SMG                   ;32
                dc.b ITEM_NONE                  ;33
                dc.b ITEM_MEDIKIT               ;34 Soldier 2
                dc.b ITEM_NONE                  ;35
                dc.b ITEM_FLAMETHR              ;36
                dc.b ITEM_FLAMETHR              ;37
                dc.b ITEM_LASERRIFLE            ;38 Guard 1
                dc.b ITEM_LASERRIFLE            ;39
                dc.b ITEM_NONE                  ;40
                dc.b ITEM_MEDIKIT               ;41 Guard 2
                dc.b ITEM_NONE                  ;42
                dc.b ITEM_GASFIST               ;43
                dc.b ITEM_GASFIST

ITEMINDEX_GUARD1 = 38

bossrewardtbllo:dc.b <gangleaderdefeated
                dc.b <guarddefeated
                dc.b <bigrobotdefeated
                dc.b <generaldefeated

bossrewardtblhi:dc.b >gangleaderdefeated
                dc.b >guarddefeated
                dc.b >bigrobotdefeated
                dc.b >generaldefeated

arhlcpt_movetbl:dc.b 80,-4,0           ;0
                dc.b 50,-2*8,-1*8       ;3
                dc.b 25,0,0
                dc.b 50,-2*8,1*8
                dc.b 25,0,0
                dc.b 50,2*8,1*8
                dc.b 25,0,0
                dc.b 50,2*8,-1*8
                dc.b 50,0,0
                dc.b 50,-4*8,4
                dc.b 25,0,0
                dc.b 50,4*8,4
                dc.b 25,0,0
                dc.b 100,0,-4
                dc.b 25,0,0
                dc.b 0,3

        ;Frame tables

fr_plrrun:      dc.b PLRB+15,PLRB+20    ;Left
                dc.b PLRB+14,PLRB+21
                dc.b PLRB+14,PLRB+22
                dc.b PLRB+15,PLRB+23
                dc.b PLRB+16,PLRB+21
                dc.b PLRB+16,PLRB+22
                dc.b PLRB+15,PLRB+23
                dc.b PLRB+14,PLRB+24
                dc.b PLRB+34,PLRB+32
                dc.b PLRB+1,PLRB+6      ;Right
                dc.b PLRB,PLRB+7
                dc.b PLRB,PLRB+8
                dc.b PLRB+1,PLRB+9
                dc.b PLRB+2,PLRB+7
                dc.b PLRB+2,PLRB+8
                dc.b PLRB+1,PLRB+9
                dc.b PLRB,PLRB+10
                dc.b PLRB+34,PLRB+32
fr_plrduck:     dc.b PLRB+15,PLRB+25    ;Left
                dc.b PLRB+1,PLRB+11     ;Right
fr_plrclimb:    dc.b PLRB+29,PLRB+32
                dc.b PLRB+28,PLRB+31
                dc.b PLRB+29,PLRB+32
                dc.b PLRB+30,PLRB+33
fr_plrout:      dc.b PLRB+39,PLRB+40    ;Left
                dc.b PLRB+41,PLRB+42
                dc.b PLRB+35,PLRB+36    ;Right
                dc.b PLRB+37,PLRB+38

fr_playerjetbike:
                dc.b LVLSPRB+86,LVLSPRB+87
                dc.b LVLSPRB+88,LVLSPRB+87

fr_item:        dc.b EMPTYSPRITE        ;Nothing
                dc.b EMPTYSPRITE        ;Fists
                dc.b ITEMB+7            ;Cat-5 whip
                dc.b ITEMB+8            ;Knife
                dc.b ITEMB+9            ;Nunchaku
                dc.b ITEMB+6            ;Grenades
                dc.b ITEMB              ;Pistol
                dc.b ITEMB+1            ;Shotgun
                dc.b ITEMB+2            ;Submachinegun
                dc.b ITEMB+3            ;Flame thrower
                dc.b ITEMB+4            ;Missile launcher
                dc.b ITEMB+4            ;Laser rifle
                dc.b ITEMB+5            ;Gas fist
                dc.b ITEMB+13           ;Medikit
                dc.b ITEMB+16           ;Food
                dc.b EMPTYSPRITE        ;Beer
                dc.b ITEMB+12           ;Credits
                dc.b ITEMB+10           ;9mm bullets
                dc.b ITEMB+10           ;Shotgun shells
                dc.b ITEMB+10           ;Mini-missiles
                dc.b ITEMB+11           ;Flamethrower fuel
                dc.b ITEMB+11           ;Batteries
                dc.b ITEMB+14           ;Ctrl.room key
                dc.b ITEMB+17           ;Radio equipment
                dc.b ITEMB+15           ;Helipad keycard
                dc.b ITEMB+14           ;Cell key
                dc.b ITEMB+20           ;Guitar pick
                dc.b ITEMB+14           ;Apartment key
                dc.b ITEMB+19           ;Bootdisk
                dc.b ITEMB+18           ;CD-rom disk
                dc.b EMPTYSPRITE        ;Access log
                dc.b ITEMB+15           ;Keycard
                dc.b ITEMB+15           ;Keycard
                dc.b ITEMB+15           ;Keycard
                dc.b LVLSPRB+100        ;Doctor's coat

fr_guard1out:
fr_gunmanout:   dc.b LVLSPRB+16,LVLSPRB+17      ;Left
                dc.b LVLSPRB+18,LVLSPRB+19
                dc.b LVLSPRB+6,LVLSPRB+7        ;Right
                dc.b LVLSPRB+8,LVLSPRB+9

fr_knifeman:    dc.b LVLSPRB+32,LVLSPRB+13  ;Left
                dc.b LVLSPRB+32,LVLSPRB+14
                dc.b LVLSPRB+33,LVLSPRB+15
                dc.b LVLSPRB+34,LVLSPRB+13
                dc.b LVLSPRB+34,LVLSPRB+14
                dc.b LVLSPRB+33,LVLSPRB+15
                dc.b LVLSPRB+34,LVLSPRB+25
                dc.b LVLSPRB+35,LVLSPRB+23
                dc.b LVLSPRB+39,LVLSPRB+23
                dc.b LVLSPRB+26,LVLSPRB+3  ;Right
                dc.b LVLSPRB+26,LVLSPRB+4
                dc.b LVLSPRB+27,LVLSPRB+5
                dc.b LVLSPRB+28,LVLSPRB+3
                dc.b LVLSPRB+28,LVLSPRB+4
                dc.b LVLSPRB+27,LVLSPRB+5
                dc.b LVLSPRB+28,LVLSPRB+24
                dc.b LVLSPRB+29,LVLSPRB+21
                dc.b LVLSPRB+38,LVLSPRB+21
fr_knifemanout: dc.b LVLSPRB+16,LVLSPRB+36      ;Left
                dc.b LVLSPRB+18,LVLSPRB+37
                dc.b LVLSPRB+30,LVLSPRB+7        ;Right
                dc.b LVLSPRB+31,LVLSPRB+9

fr_anarchist:   dc.b LVLSPRB+46,LVLSPRB+59  ;Left
                dc.b LVLSPRB+46,LVLSPRB+60
                dc.b LVLSPRB+47,LVLSPRB+61
                dc.b LVLSPRB+48,LVLSPRB+59
                dc.b LVLSPRB+48,LVLSPRB+60
                dc.b LVLSPRB+47,LVLSPRB+61
                dc.b LVLSPRB+48,LVLSPRB+63
                dc.b LVLSPRB+49,LVLSPRB+62
                dc.b LVLSPRB+40,LVLSPRB+52 ;Right
                dc.b LVLSPRB+40,LVLSPRB+53
                dc.b LVLSPRB+41,LVLSPRB+54
                dc.b LVLSPRB+42,LVLSPRB+52
                dc.b LVLSPRB+42,LVLSPRB+53
                dc.b LVLSPRB+41,LVLSPRB+54
                dc.b LVLSPRB+42,LVLSPRB+56
                dc.b LVLSPRB+43,LVLSPRB+55
fr_anarchistout:dc.b LVLSPRB+64,LVLSPRB+50      ;Left
                dc.b LVLSPRB+65,LVLSPRB+51
                dc.b LVLSPRB+44,LVLSPRB+57      ;Right
                dc.b LVLSPRB+45,LVLSPRB+58

fr_motorist:    dc.b LVLSPRB+70,LVLSPRB+71,LVLSPRB+72,LVLSPRB+73 ;Left
                dc.b LVLSPRB+66,LVLSPRB+67,LVLSPRB+68,LVLSPRB+69 ;Right
fr_motoristout: dc.b LVLSPRB+64,LVLSPRB+17      ;Left
                dc.b LVLSPRB+65,LVLSPRB+19
                dc.b LVLSPRB+6,LVLSPRB+57        ;Right
                dc.b LVLSPRB+8,LVLSPRB+58

fr_shotgunman:  dc.b LVLSPRB+102,LVLSPRB+13  ;Left
                dc.b LVLSPRB+102,LVLSPRB+14
                dc.b LVLSPRB+103,LVLSPRB+15
                dc.b LVLSPRB+102,LVLSPRB+13
                dc.b LVLSPRB+102,LVLSPRB+14
                dc.b LVLSPRB+103,LVLSPRB+15
                dc.b LVLSPRB+102,LVLSPRB+25
                dc.b LVLSPRB+103,LVLSPRB+23
                dc.b LVLSPRB+98,LVLSPRB+3  ;Right
                dc.b LVLSPRB+98,LVLSPRB+4
                dc.b LVLSPRB+99,LVLSPRB+5
                dc.b LVLSPRB+98,LVLSPRB+3
                dc.b LVLSPRB+98,LVLSPRB+4
                dc.b LVLSPRB+99,LVLSPRB+5
                dc.b LVLSPRB+98,LVLSPRB+24
                dc.b LVLSPRB+99,LVLSPRB+21
fr_shotgmanout: dc.b LVLSPRB+16,LVLSPRB+104      ;Left
                dc.b LVLSPRB+18,LVLSPRB+105
                dc.b LVLSPRB+100,LVLSPRB+7        ;Right
                dc.b LVLSPRB+101,LVLSPRB+9

fr_guard1:
fr_gunman:
fr_uziman:      dc.b LVLSPRB+10,LVLSPRB+13  ;Left
                dc.b LVLSPRB+10,LVLSPRB+14
                dc.b LVLSPRB+11,LVLSPRB+15
                dc.b LVLSPRB+12,LVLSPRB+13
                dc.b LVLSPRB+12,LVLSPRB+14
                dc.b LVLSPRB+11,LVLSPRB+15
                dc.b LVLSPRB+12,LVLSPRB+25
                dc.b LVLSPRB+22,LVLSPRB+23
                dc.b LVLSPRB+28,LVLSPRB+23
                dc.b LVLSPRB+29,LVLSPRB+23
                dc.b LVLSPRB,LVLSPRB+3  ;Right
                dc.b LVLSPRB,LVLSPRB+4
                dc.b LVLSPRB+1,LVLSPRB+5
                dc.b LVLSPRB+2,LVLSPRB+3
                dc.b LVLSPRB+2,LVLSPRB+4
                dc.b LVLSPRB+1,LVLSPRB+5
                dc.b LVLSPRB+2,LVLSPRB+24
                dc.b LVLSPRB+20,LVLSPRB+21
                dc.b LVLSPRB+26,LVLSPRB+21
                dc.b LVLSPRB+27,LVLSPRB+21

fr_gangleader:  dc.b LVLSPRB+36,LVLSPRB+59  ;Left
                dc.b LVLSPRB+36,LVLSPRB+60
                dc.b LVLSPRB+37,LVLSPRB+61
                dc.b LVLSPRB+38,LVLSPRB+59
                dc.b LVLSPRB+38,LVLSPRB+60
                dc.b LVLSPRB+37,LVLSPRB+61
                dc.b LVLSPRB+38,LVLSPRB+63
                dc.b LVLSPRB+39,LVLSPRB+62
                dc.b LVLSPRB+69,LVLSPRB+62
                dc.b LVLSPRB+30,LVLSPRB+52 ;Right
                dc.b LVLSPRB+30,LVLSPRB+53
                dc.b LVLSPRB+31,LVLSPRB+54
                dc.b LVLSPRB+32,LVLSPRB+52
                dc.b LVLSPRB+32,LVLSPRB+53
                dc.b LVLSPRB+31,LVLSPRB+54
                dc.b LVLSPRB+32,LVLSPRB+56
                dc.b LVLSPRB+33,LVLSPRB+55
                dc.b LVLSPRB+68,LVLSPRB+55
fr_gangleaderout:dc.b LVLSPRB+64,LVLSPRB+66      ;Left
                dc.b LVLSPRB+65,LVLSPRB+67
                dc.b LVLSPRB+34,LVLSPRB+57      ;Right
                dc.b LVLSPRB+35,LVLSPRB+58

fr_mutantpig:   dc.b LVLSPRB+75                 ;Left
                dc.b LVLSPRB+76
                dc.b LVLSPRB+77
                dc.b LVLSPRB+70                 ;Right
                dc.b LVLSPRB+71
                dc.b LVLSPRB+72
fr_mutantpigout:dc.b LVLSPRB+78                 ;Left
                dc.b LVLSPRB+79
                dc.b LVLSPRB+73                 ;Right
                dc.b LVLSPRB+74

fr_airplane:    dc.b LVLSPRB+86,LVLSPRB+87      ;Left
                dc.b LVLSPRB+88,LVLSPRB+89
                dc.b LVLSPRB+86,LVLSPRB+90
                dc.b LVLSPRB+88,LVLSPRB+91
                dc.b LVLSPRB+80,LVLSPRB+81      ;Right
                dc.b LVLSPRB+82,LVLSPRB+83
                dc.b LVLSPRB+84,LVLSPRB+81
                dc.b LVLSPRB+85,LVLSPRB+83

fr_mutantrat:   dc.b LVLSPRB+95                 ;Left
                dc.b LVLSPRB+96
                dc.b LVLSPRB+96
                dc.b LVLSPRB+92                 ;Right
                dc.b LVLSPRB+93
                dc.b LVLSPRB+93
fr_mutantratout:dc.b LVLSPRB+97                 ;Left
                dc.b LVLSPRB+97
                dc.b LVLSPRB+94                 ;Right
                dc.b LVLSPRB+94

fr_guard2:
fr_soldier2:    dc.b LVLSPRB+36,LVLSPRB+13  ;Left
                dc.b LVLSPRB+36,LVLSPRB+14
                dc.b LVLSPRB+37,LVLSPRB+15
                dc.b LVLSPRB+38,LVLSPRB+13
                dc.b LVLSPRB+38,LVLSPRB+14
                dc.b LVLSPRB+37,LVLSPRB+15
                dc.b LVLSPRB+38,LVLSPRB+25
                dc.b LVLSPRB+39,LVLSPRB+23
                dc.b LVLSPRB+30,LVLSPRB+3  ;Right
                dc.b LVLSPRB+30,LVLSPRB+4
                dc.b LVLSPRB+31,LVLSPRB+5
                dc.b LVLSPRB+32,LVLSPRB+3
                dc.b LVLSPRB+32,LVLSPRB+4
                dc.b LVLSPRB+31,LVLSPRB+5
                dc.b LVLSPRB+32,LVLSPRB+24
                dc.b LVLSPRB+33,LVLSPRB+21
fr_guard2out:
fr_soldier2out: dc.b LVLSPRB+16,LVLSPRB+40      ;Left
                dc.b LVLSPRB+18,LVLSPRB+41
                dc.b LVLSPRB+34,LVLSPRB+7        ;Right
                dc.b LVLSPRB+35,LVLSPRB+9

fr_dog:         dc.b LVLSPRB+47                 ;Left
                dc.b LVLSPRB+48
                dc.b LVLSPRB+49
                dc.b LVLSPRB+48
                dc.b LVLSPRB+42                 ;Right
                dc.b LVLSPRB+43
                dc.b LVLSPRB+44
                dc.b LVLSPRB+43
fr_dogout:      dc.b LVLSPRB+50                 ;Left
                dc.b LVLSPRB+51
                dc.b LVLSPRB+45                 ;Right
                dc.b LVLSPRB+46

fr_hawk:        dc.b LVLSPRB+55                 ;Left
                dc.b LVLSPRB+56
                dc.b LVLSPRB+57
                dc.b LVLSPRB+56
                dc.b LVLSPRB+52                 ;Right
                dc.b LVLSPRB+53
                dc.b LVLSPRB+54
                dc.b LVLSPRB+53

fr_hawkout:     dc.b LVLSPRB+56                 ;Left
                dc.b LVLSPRB+59
                dc.b LVLSPRB+53                 ;Right
                dc.b LVLSPRB+58

fr_towergunner: dc.b LVLSPRB+29
                dc.b LVLSPRB+27

fr_jetbikeout:
fr_enemyjetbike:dc.b LVLSPRB+89,LVLSPRB+90
                dc.b LVLSPRB+91,LVLSPRB+92
                dc.b LVLSPRB+93,LVLSPRB+94
                dc.b LVLSPRB+91,LVLSPRB+92

fr_helicopterout:
fr_helicopter:  dc.b LVLSPRB+95,LVLSPRB+96,LVLSPRB+97,LVLSPRB+98
                dc.b LVLSPRB+99,LVLSPRB+100,LVLSPRB+101,LVLSPRB+102
                dc.b LVLSPRB+103,LVLSPRB+104,LVLSPRB+105,LVLSPRB+85
                dc.b LVLSPRB+99,LVLSPRB+100,LVLSPRB+101,LVLSPRB+102

fr_bigrobotout:
fr_bigrobot:    dc.b LVLSPRB+42,LVLSPRB+43,LVLSPRB+44
                dc.b LVLSPRB+45,LVLSPRB+46,LVLSPRB+47
                dc.b LVLSPRB+42,LVLSPRB+43,LVLSPRB+44
                dc.b LVLSPRB+48,LVLSPRB+49,LVLSPRB+50
                dc.b LVLSPRB+42,LVLSPRB+43,LVLSPRB+44
                dc.b LVLSPRB+45,LVLSPRB+46,LVLSPRB+47
                dc.b LVLSPRB+42,LVLSPRB+43,LVLSPRB+44
                dc.b LVLSPRB+51,LVLSPRB+52,LVLSPRB+53

fr_general:     dc.b LVLSPRB+79,LVLSPRB+13  ;Left
                dc.b LVLSPRB+79,LVLSPRB+14
                dc.b LVLSPRB+80,LVLSPRB+15
                dc.b LVLSPRB+81,LVLSPRB+13
                dc.b LVLSPRB+81,LVLSPRB+14
                dc.b LVLSPRB+80,LVLSPRB+15
                dc.b LVLSPRB+81,LVLSPRB+25
                dc.b LVLSPRB+82,LVLSPRB+23
                dc.b LVLSPRB+73,LVLSPRB+3  ;Right
                dc.b LVLSPRB+73,LVLSPRB+4
                dc.b LVLSPRB+74,LVLSPRB+5
                dc.b LVLSPRB+75,LVLSPRB+3
                dc.b LVLSPRB+75,LVLSPRB+4
                dc.b LVLSPRB+74,LVLSPRB+5
                dc.b LVLSPRB+75,LVLSPRB+24
                dc.b LVLSPRB+76,LVLSPRB+21
fr_generalout:  dc.b LVLSPRB+16,LVLSPRB+83      ;Left
                dc.b LVLSPRB+18,LVLSPRB+84
                dc.b LVLSPRB+77,LVLSPRB+7        ;Right
                dc.b LVLSPRB+78,LVLSPRB+9



fr_bystander1:  dc.b LVLSPRB+77,LVLSPRB+13  ;Left
                dc.b LVLSPRB+77,LVLSPRB+14
                dc.b LVLSPRB+78,LVLSPRB+15
                dc.b LVLSPRB+79,LVLSPRB+13
                dc.b LVLSPRB+79,LVLSPRB+14
                dc.b LVLSPRB+78,LVLSPRB+15
                dc.b LVLSPRB+74,LVLSPRB+3  ;Right
                dc.b LVLSPRB+74,LVLSPRB+4
                dc.b LVLSPRB+75,LVLSPRB+5
                dc.b LVLSPRB+76,LVLSPRB+3
                dc.b LVLSPRB+76,LVLSPRB+4
                dc.b LVLSPRB+75,LVLSPRB+5

fr_bystander2:  dc.b LVLSPRB+83,LVLSPRB+59  ;Left
                dc.b LVLSPRB+83,LVLSPRB+60
                dc.b LVLSPRB+84,LVLSPRB+61
                dc.b LVLSPRB+85,LVLSPRB+59
                dc.b LVLSPRB+85,LVLSPRB+60
                dc.b LVLSPRB+84,LVLSPRB+61
                dc.b LVLSPRB+80,LVLSPRB+52 ;Right
                dc.b LVLSPRB+80,LVLSPRB+53
                dc.b LVLSPRB+81,LVLSPRB+54
                dc.b LVLSPRB+82,LVLSPRB+52
                dc.b LVLSPRB+82,LVLSPRB+53
                dc.b LVLSPRB+81,LVLSPRB+54

fr_bystander3:  dc.b LVLSPRB+89,LVLSPRB+59  ;Left
                dc.b LVLSPRB+89,LVLSPRB+60
                dc.b LVLSPRB+90,LVLSPRB+61
                dc.b LVLSPRB+91,LVLSPRB+59
                dc.b LVLSPRB+91,LVLSPRB+60
                dc.b LVLSPRB+90,LVLSPRB+61
                dc.b LVLSPRB+86,LVLSPRB+52  ;Right
                dc.b LVLSPRB+86,LVLSPRB+53
                dc.b LVLSPRB+87,LVLSPRB+54
                dc.b LVLSPRB+88,LVLSPRB+52
                dc.b LVLSPRB+88,LVLSPRB+53
                dc.b LVLSPRB+87,LVLSPRB+54

fr_bystander4:  dc.b LVLSPRB+95,LVLSPRB+13  ;Left
                dc.b LVLSPRB+95,LVLSPRB+14
                dc.b LVLSPRB+96,LVLSPRB+15
                dc.b LVLSPRB+97,LVLSPRB+13
                dc.b LVLSPRB+97,LVLSPRB+14
                dc.b LVLSPRB+96,LVLSPRB+15
                dc.b LVLSPRB+92,LVLSPRB+3  ;Right
                dc.b LVLSPRB+92,LVLSPRB+4
                dc.b LVLSPRB+93,LVLSPRB+5
                dc.b LVLSPRB+94,LVLSPRB+3
                dc.b LVLSPRB+94,LVLSPRB+4
                dc.b LVLSPRB+93,LVLSPRB+5

fr_truck:       dc.b LVLSPRB+60,LVLSPRB+61,LVLSPRB+62,LVLSPRB+63
                dc.b LVLSPRB+64,LVLSPRB+65,LVLSPRB+66,LVLSPRB+67
                dc.b LVLSPRB+68,LVLSPRB+69,LVLSPRB+70,LVLSPRB+71
                dc.b LVLSPRB+60,LVLSPRB+61,LVLSPRB+62,LVLSPRB+63
                dc.b LVLSPRB+64,LVLSPRB+65,LVLSPRB+66,LVLSPRB+67
                dc.b LVLSPRB+72,LVLSPRB+69,LVLSPRB+70,LVLSPRB+73

fr_jetbike:     dc.b LVLSPRB+78,LVLSPRB+79

fr_explosion:   dc.b EXPLB
                dc.b EXPLB+1
                dc.b EXPLB+2
                dc.b EXPLB+3
                dc.b EXPLB+4
                dc.b EXPLB+5

fr_groundflame: dc.b PLRB-3
                dc.b PLRB-2
                dc.b PLRB-1
                dc.b EMPTYSPRITE
                dc.b EMPTYSPRITE

fr_shopkeeper:  dc.b EMPTYSPRITE
                dc.b LVLSPRB
                dc.b LVLSPRB+1
                dc.b LVLSPRB+1
                dc.b LVLSPRB+2
                dc.b LVLSPRB+3
                dc.b LVLSPRB+4
                dc.b LVLSPRB+5
                dc.b LVLSPRB+6
                dc.b LVLSPRB+7
                dc.b LVLSPRB+8
                dc.b LVLSPRB+9
                dc.b LVLSPRB+10
                dc.b LVLSPRB+87
                dc.b LVLSPRB+87
                dc.b LVLSPRB+60

fr_customer1:   dc.b LVLSPRB+11,LVLSPRB+14
                dc.b LVLSPRB+12,LVLSPRB+14
                dc.b LVLSPRB+13,LVLSPRB+14
                dc.b LVLSPRB+12,LVLSPRB+14

fr_customer2:   dc.b LVLSPRB+15,LVLSPRB+18
                dc.b LVLSPRB+16,LVLSPRB+18
                dc.b LVLSPRB+17,LVLSPRB+18
                dc.b LVLSPRB+16,LVLSPRB+18

fr_customer3:   dc.b LVLSPRB+19,LVLSPRB+14
                dc.b LVLSPRB+20,LVLSPRB+14
                dc.b LVLSPRB+21,LVLSPRB+14
                dc.b LVLSPRB+20,LVLSPRB+14

fr_customer4:   dc.b LVLSPRB+22,LVLSPRB+25
                dc.b LVLSPRB+23,LVLSPRB+25
                dc.b LVLSPRB+24,LVLSPRB+25
                dc.b LVLSPRB+23,LVLSPRB+25

fr_customer5:   dc.b LVLSPRB+26,LVLSPRB+29
                dc.b LVLSPRB+27,LVLSPRB+29
                dc.b LVLSPRB+28,LVLSPRB+29
                dc.b LVLSPRB+27,LVLSPRB+29

fr_customer6:   dc.b LVLSPRB+30,LVLSPRB+33
                dc.b LVLSPRB+31,LVLSPRB+33
                dc.b LVLSPRB+32,LVLSPRB+33
                dc.b LVLSPRB+31,LVLSPRB+33

fr_customer8:   dc.b LVLSPRB+34,LVLSPRB+37
                dc.b LVLSPRB+35,LVLSPRB+37
                dc.b LVLSPRB+36,LVLSPRB+37
                dc.b LVLSPRB+35,LVLSPRB+37

fr_band1:       dc.b LVLSPRB+38,LVLSPRB+42,LVLSPRB+44,LVLSPRB+41,EMPTYSPRITE,LVLSPRB+48
                dc.b LVLSPRB+39,LVLSPRB+43,LVLSPRB+45,LVLSPRB+41,EMPTYSPRITE,LVLSPRB+48
                dc.b LVLSPRB+40,LVLSPRB+42,LVLSPRB+46,LVLSPRB+41,EMPTYSPRITE,LVLSPRB+48
                dc.b LVLSPRB+39,LVLSPRB+43,LVLSPRB+47,LVLSPRB+41,EMPTYSPRITE,LVLSPRB+48

fr_band2:       dc.b LVLSPRB+49,LVLSPRB+42,LVLSPRB+54,LVLSPRB+53,EMPTYSPRITE,LVLSPRB+58
                dc.b LVLSPRB+50,LVLSPRB+43,LVLSPRB+55,LVLSPRB+53,EMPTYSPRITE,LVLSPRB+58
                dc.b LVLSPRB+51,LVLSPRB+42,LVLSPRB+56,LVLSPRB+53,EMPTYSPRITE,LVLSPRB+58
                dc.b LVLSPRB+52,LVLSPRB+43,LVLSPRB+57,LVLSPRB+53,EMPTYSPRITE,LVLSPRB+58

fr_band3:       dc.b LVLSPRB+59,LVLSPRB+64,LVLSPRB+68,LVLSPRB+63,EMPTYSPRITE,LVLSPRB+70
                dc.b LVLSPRB+60,LVLSPRB+65,LVLSPRB+69,LVLSPRB+63,EMPTYSPRITE,LVLSPRB+70
                dc.b LVLSPRB+61,LVLSPRB+66,LVLSPRB+68,LVLSPRB+63,EMPTYSPRITE,LVLSPRB+70
                dc.b LVLSPRB+62,LVLSPRB+67,LVLSPRB+69,LVLSPRB+63,EMPTYSPRITE,LVLSPRB+70

fr_sexrobot:    dc.b LVLSPRB+71,LVLSPRB+72
                dc.b LVLSPRB+73,LVLSPRB+74
                dc.b LVLSPRB+75,LVLSPRB+76
                dc.b LVLSPRB+77,LVLSPRB+78
                dc.b LVLSPRB+71,LVLSPRB+74
                dc.b LVLSPRB+77,LVLSPRB+72
                dc.b LVLSPRB+75,LVLSPRB+78
                dc.b LVLSPRB+73,LVLSPRB+76

fr_snake:       dc.b LVLSPRB+79,LVLSPRB+80
                dc.b LVLSPRB+81,LVLSPRB+82

fr_hammer:      dc.b LVLSPRB+83,LVLSPRB+84

fr_ultrashred:  dc.b LVLSPRB+85,LVLSPRB+86

fr_colonel:     dc.b LVLSPRB+74,LVLSPRB+75

fr_prisonkeeper:dc.b LVLSPRB+76,LVLSPRB+77

fr_scientist:   dc.b LVLSPRB+69,LVLSPRB+72
                dc.b LVLSPRB+70,LVLSPRB+72
                dc.b LVLSPRB+71,LVLSPRB+72
                dc.b LVLSPRB+70,LVLSPRB+72

fr_bofh:        dc.b LVLSPRB+26,LVLSPRB+29
                dc.b LVLSPRB+27,LVLSPRB+29
                dc.b LVLSPRB+28,LVLSPRB+29
                dc.b LVLSPRB+27,LVLSPRB+29

fr_worker1:     dc.b LVLSPRB+61,LVLSPRB+62
fr_worker2:     dc.b LVLSPRB+63,LVLSPRB+64
fr_worker3:     dc.b LVLSPRB+65,LVLSPRB+66
fr_worker4:     dc.b LVLSPRB+67,LVLSPRB+68

fr_doctor:      dc.b LVLSPRB+91,LVLSPRB+97  ;Left
                dc.b LVLSPRB+91,LVLSPRB+98
                dc.b LVLSPRB+92,LVLSPRB+99
                dc.b LVLSPRB+93,LVLSPRB+97
                dc.b LVLSPRB+93,LVLSPRB+98
                dc.b LVLSPRB+92,LVLSPRB+99
                dc.b LVLSPRB+88,LVLSPRB+94  ;Right
                dc.b LVLSPRB+88,LVLSPRB+95
                dc.b LVLSPRB+89,LVLSPRB+96
                dc.b LVLSPRB+90,LVLSPRB+94
                dc.b LVLSPRB+90,LVLSPRB+95
                dc.b LVLSPRB+89,LVLSPRB+96

        ;PLAYER.S data
        ;-------------

pwdlettertbl:   dc.b "01234567"
                dc.b "89ABCDEF"
                dc.b "HJKLMNPQ"
                dc.b "RTUVWXYZ"

orbittbl:
pwdbittbl:      dc.b $01,$02,$04,$08,$10,$20,$40,$80

stmcolortbl:    dc.b $3b
                dc.b $91
                dc.b $42
                dc.b $61
                dc.b $87
                dc.b $a1
                dc.b $3b
                dc.b $31
                dc.b $47
                dc.b $31
                dc.b $47
                dc.b $31
                dc.b $47
                dc.b $61
                dc.b $00

timecltbl:      dc.b CLMODE_NIGHT       ;00-01
                dc.b CLMODE_NIGHT       ;02-03
                dc.b CLMODE_NIGHT       ;04-05
                dc.b CLMODE_MORNING     ;06-07
                dc.b CLMODE_DAY         ;08-09
                dc.b CLMODE_DAY         ;Illegal BCD value
                dc.b CLMODE_DAY         ;Illegal BCD value
                dc.b CLMODE_DAY         ;Illegal BCD value
                dc.b CLMODE_DAY         ;10-11
                dc.b CLMODE_DAY         ;12-13
                dc.b CLMODE_DAY         ;14-15
                dc.b CLMODE_DAY         ;16-17
                dc.b CLMODE_EVENING     ;18-19
                dc.b CLMODE_EVENING     ;Illegal BCD value
                dc.b CLMODE_EVENING     ;Illegal BCD value
                dc.b CLMODE_EVENING     ;Illegal BCD value
                dc.b CLMODE_EVENING     ;20-21
                dc.b CLMODE_NIGHT       ;22-23

cscr_xtbl:      dc.b -2,-2,-2,-2,-1,0,1,2
cscr_ytbl:      dc.b -2,-2,-2,0,0,0,2,2

scoretbl1:      dc.b $00,$00,$00,$00,$00,$00,$00,$00
                dc.b $00,$00,$00,$01,$02,$05,$10
scoretbl2:      dc.b $00,$01,$02,$02,$03,$05,$07,$10
                dc.b $15,$25,$50,$00,$50,$00,$00
scoretbl3:      dc.b $50,$00,$00,$50,$50,$00,$50,$00
                dc.b $00,$00,$00,$00,$00,$00,$00

climbspdtbl:    dc.b 32,40,48,56,64,72
jumpspdtbl:     dc.b -20,-21,-22,-23,-24,-25

attkframetblr:  dc.b PLRB+1,PLRB+12,PLRB+13,PLRB+3,PLRB+4,PLRB+5
attkframetbll:  dc.b PLRB+15,PLRB+26,PLRB+27,PLRB+17,PLRB+18,PLRB+19

gunmultbl:      dc.b 0,9,18,27,36,36,45
meleefrtbl:     dc.b 0,5,3
meleemultbl:    dc.b 3,0
meleemultbl2:   dc.b 128,54,60,66,128
meleeblttbl:    dc.b BLT_FISTHIT, BLT_WHIPHIT, BLT_KNIFEHIT, BLT_NUNCHAKUHIT, BLT_GRENADE

gunsprtbl:      dc.b 0,10,5
                dc.b 0,10,6
                dc.b 0,10,7
                dc.b 0,10,8
                dc.b 0,10,9
                dc.b 0,10,10
                dc.b 0,10,5
                dc.b 0,10,6
                dc.b 0,10,7
                dc.b 0,11,11
                dc.b 0,11,12
                dc.b 0,11,13
                dc.b 0,10,14
                dc.b 0,10,15
                dc.b 0,10,16
                dc.b 0,10,17
                dc.b 0,8,18
                dc.b 0,10,19
                dc.b -16,0,0
                dc.b 24,4,1
                dc.b 12,5,2
                dc.b 18,4,2
                dc.b -16,4,3
                dc.b 20,4,4

tminitagility:  dc.b 2,2,3,1,3,4
tminitstrength: dc.b 2,2,1,3,2,1
tminitvitality: dc.b 2,2,2,2,1,1

abilityindex:   dc.b 0,MAXTM,MAXTM*2

        ;ITEM.S data
        ;-----------

creditstbl:     dc.b $02,$03,$05,$10

digitpostbl:    dc.b 41,43,45,47

itemnametbllo:  dc.b <itemname0
                dc.b <itemname1
                dc.b <itemname2
                dc.b <itemname3
                dc.b <itemname4
                dc.b <itemname5
                dc.b <itemname6
                dc.b <itemname7
                dc.b <itemname8
                dc.b <itemname9
                dc.b <itemname10
                dc.b <itemname11
                dc.b <itemname12
                dc.b <itemname13
                dc.b <itemname14
                dc.b <itemname15
                dc.b <itemname16
                dc.b <itemname17
                dc.b <itemname18
                dc.b <itemname19
                dc.b <itemname20
                dc.b <itemname21
                dc.b <itemname22
                dc.b <itemname23
                dc.b <itemname24
                dc.b <itemname25
                dc.b <itemname26
                dc.b <itemname27
                dc.b <itemname28
                dc.b <itemname29
                dc.b <itemname30
                dc.b <itemname31
                dc.b <itemname32
                dc.b <itemname33
                dc.b <itemname34

itemnametblhi:  dc.b >itemname0
                dc.b >itemname1
                dc.b >itemname2
                dc.b >itemname3
                dc.b >itemname4
                dc.b >itemname5
                dc.b >itemname6
                dc.b >itemname7
                dc.b >itemname8
                dc.b >itemname9
                dc.b >itemname10
                dc.b >itemname11
                dc.b >itemname12
                dc.b >itemname13
                dc.b >itemname14
                dc.b >itemname15
                dc.b >itemname16
                dc.b >itemname17
                dc.b >itemname18
                dc.b >itemname19
                dc.b >itemname20
                dc.b >itemname21
                dc.b >itemname22
                dc.b >itemname23
                dc.b >itemname24
                dc.b >itemname25
                dc.b >itemname26
                dc.b >itemname27
                dc.b >itemname28
                dc.b >itemname29
                dc.b >itemname30
                dc.b >itemname31
                dc.b >itemname32
                dc.b >itemname33
                dc.b >itemname34

itemaddtbl:     dc.b 0
                dc.b 0           ;Fists
                dc.b 0           ;Whip
                dc.b 0           ;Knife
                dc.b 0           ;Nunchaku
                dc.b $05         ;Grenades
                dc.b $20         ;Pistol
                dc.b $10         ;Shotgun
                dc.b $30         ;SMG
                dc.b $50         ;Flame thrower
                dc.b $10         ;Missile launcher
                dc.b $30         ;Laser rifle
                dc.b $30         ;Gas fist
                dc.b $01         ;Medikit
                dc.b $01         ;Food
                dc.b $01         ;Beer
                dc.b 0           ;Credits
                dc.b $50         ;9mm bullets
                dc.b $25         ;Shells
                dc.b $10         ;Mini-missiles
                dc.b $50         ;Flamethrower fuel
                dc.b $30         ;Batteries
                dc.b 0           ;Control room key
                dc.b 0           ;Radio gear
                dc.b 0           ;Helipad keycard
                dc.b 0           ;Cell key
                dc.b 0           ;Guitar pick
                dc.b 0           ;Apartment key
                dc.b 0           ;Bootdisk
                dc.b 0           ;CD-rom
                dc.b 0           ;Access log
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Doctor's coat

itemmaxtbllo:   dc.b 0
                dc.b 0            ;Fists
                dc.b 0            ;Whip
                dc.b 0            ;Knife
                dc.b 0            ;Nunchaku
                dc.b <$20         ;Grenades
                dc.b <$20         ;Pistol
                dc.b <$10         ;Shotgun
                dc.b <$30         ;SMG
                dc.b <$50         ;Flame thrower
                dc.b <$10         ;Missile launcher
                dc.b <$30         ;Laser rifle
                dc.b <$30         ;Gas fist
                dc.b 0            ;Medikit
                dc.b <$3          ;Food
                dc.b <$3          ;Beer
                dc.b <$9999       ;Credits
                dc.b 0            ;9mm bullets
                dc.b 0            ;Shells
                dc.b 0            ;Mini-missiles
                dc.b 0            ;Flamethrower fuel
                dc.b 0            ;Batteries
                dc.b 0            ;Control room key
                dc.b 0            ;Radio gear
                dc.b 0           ;Helipad keycard
                dc.b 0           ;Cell key
                dc.b 0           ;Guitar pick
                dc.b 0           ;Apartment key
                dc.b 0           ;Bootdisk
                dc.b 0           ;CD-rom
                dc.b 0           ;Access log
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Doctor's coat

itemmaxtblhi:   dc.b 0
                dc.b 0            ;Fists
                dc.b 0            ;Whip
                dc.b 0            ;Knife
                dc.b 0            ;Nunchaku
                dc.b 0            ;Grenades
                dc.b >$20         ;Pistol
                dc.b >$10         ;Shotgun
                dc.b >$30         ;SMG
                dc.b >$50         ;Flame thrower
                dc.b >$10         ;Missile launcher
                dc.b >$30         ;Laser rifle
                dc.b >$30         ;Gas fist
                dc.b 0            ;Medikit
                dc.b >$3          ;Food
                dc.b >$3          ;Beer
                dc.b >$9999       ;Credits
                dc.b 0            ;9mm bullets
                dc.b 0            ;Shells
                dc.b 0            ;Mini-missiles
                dc.b 0            ;Flamethrower fuel
                dc.b 0            ;Batteries
                dc.b 0            ;Control room key
                dc.b 0            ;Radio gear
                dc.b 0           ;Helipad keycard
                dc.b 0           ;Cell key
                dc.b 0           ;Guitar pick
                dc.b 0           ;Apartment key
                dc.b 0           ;Bootdisk
                dc.b 0           ;CD-rom
                dc.b 0           ;Access log
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Doctor's coat

itemammotbl:    dc.b 0
                dc.b 0           ;Fists
                dc.b 0           ;Whip
                dc.b 0           ;Knife
                dc.b 0           ;Nunchaku
                dc.b 0           ;Grenades
                dc.b ITEM_9MMBULLETS ;Pistol
                dc.b ITEM_SHELLS ;Shotgun
                dc.b ITEM_9MMBULLETS ;SMG
                dc.b ITEM_FUEL   ;Flame thrower
                dc.b ITEM_MISSILES ;Missile launcher
                dc.b ITEM_BATTERIES ;Laser rifle
                dc.b ITEM_BATTERIES ;Gas fist
                dc.b 0           ;Medikit
                dc.b 0           ;Food
                dc.b 0           ;Beer
                dc.b 0           ;Credits
                dc.b 0           ;9mm bullets
                dc.b 0           ;Shells
                dc.b 0           ;Mini-missiles
                dc.b 0           ;Flamethrower fuel
                dc.b 0           ;Batteries
                dc.b 0           ;Control room key
                dc.b 0           ;Radio gear
                dc.b 0           ;Helipad keycard
                dc.b 0           ;Cell key
                dc.b 0           ;Guitar pick
                dc.b 0           ;Apartment key
                dc.b 0           ;Bootdisk
                dc.b 0           ;CD-rom
                dc.b 0           ;Access log
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Keycard
                dc.b 0           ;Doctor's coat

ITEMUSETBLSIZE  = 3
itemusetype:    dc.b ITEM_MEDIKIT,ITEM_FOOD,ITEM_BEER
itemusejumplo:  dc.b <usemedikit,<usefood,<usebeer
itemusejumphi:  dc.b >usemedikit,>usefood,>usebeer

        ;COMM.S data
        ;-----------

npctbllo:       dc.b <subcitygunshop,<gymkeeper,<gymkeeper2,<axesmith
                dc.b <bar,<cheapbar,<cheapbar,<tavern
                dc.b <bar,<freecitygunshop,<metrocitygunshop,<outpostgunshop
                dc.b <police,<asylum,<cmcdesk
                dc.b <customer1,<customer2,<customer3,<customer4
                dc.b <customer5,<customer6,<customer7,<customer8
                dc.b <customer9,<customer10,<scientist,<bofh
                dc.b <hammer,<snake
                dc.b <ultrashred,<colonel,<prisonkeeper

npctblhi:       dc.b >subcitygunshop,>gymkeeper,>gymkeeper2,>axesmith
                dc.b >bar,>cheapbar,>cheapbar,>tavern
                dc.b >bar,>freecitygunshop,>metrocitygunshop,>outpostgunshop
                dc.b >police,>asylum,>cmcdesk
                dc.b >customer1,>customer2,>customer3,>customer4
                dc.b >customer5,>customer6,>customer7,>customer8
                dc.b >customer9,>customer10,>scientist,>bofh
                dc.b >hammer,>snake
                dc.b >ultrashred,>colonel,>prisonkeeper

npctypetbl:     dc.b $80,$00,$00,$00
                dc.b $80,$80,$80,$80
                dc.b $80,$80,$80,$80
                dc.b $00,$00,$00
                dc.b $00,$00,$00,$00
                dc.b $00,$00,$00,$00
                dc.b $00,$00,$00,$00
                dc.b $00,$00
                dc.b $00,$00,$00

        ;Script data for special locations
        ;---------------------------------

flightendscript:dc.b S_REMOVEITEM,ITEM_CELLKEY
                dc.b S_REMOVEITEM,ITEM_HELIPADCARD
                dc.b S_JOINTEAM,TM_IAN
                dc.b S_JOINTEAM,TM_PHANTASM
                dc.b S_ADDITEM,ITEM_APARTMENTKEY
                dc.b S_CALLCODE
                dc.w team_fullhp
                dc.b S_POKE
                dc.w teammember
                dc.b TM_IAN
                dc.b S_RUNCUTSCENE
                dc.b CUTSCENE_CROPCIRCLE

finaldoorscript:dc.b S_CHECKPLOTBIT,PB_FINALDOORENTERED
                dc.b S_BRANCHIFTRUE
                dc.w finaldoor_skiprobot
                dc.b S_CALLCODE
                dc.w generatepwd
                dc.b S_SETPLOTBIT,PB_FINALDOORENTERED
                dc.b S_CREATEACTOR,11,16,ACT_BIGROBOT,0,$08
                dc.b S_RUNCUTSCENE,CUTSCENE_EVILPLANS
finaldoor_skiprobot:
                dc.b S_QUIT

computer2script:dc.b S_CHECKPLOTBIT,PB_FINALDOOR
                dc.b S_BRANCHIFTRUE
                dc.w computer1_gotaccesslog
                dc.b S_CHECKITEM,ITEM_BOOTDISK
                dc.b S_BRANCHIFTRUE
                dc.w computer2_hacksuccess
                dc.b S_CHECKTM,TM_IAN ;Needed as hacking consultant :)
                dc.b S_BRANCHIFTRUE
                dc.w computer2_hackgame
computer2_noway:dc.b S_TEXT
                dc.w computer2text1
                dc.b S_QUIT

computer2_hacksuccess:
                dc.b S_TEXT
                dc.w computer2text2
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_SETPLOTBIT,PB_FINALDOOR
                dc.b S_TEXT
                dc.w computer2text3
                dc.b S_QUIT

computer2_hackgame:
                dc.b S_CALLCODE
                dc.w hackminigame
                dc.b S_BRANCHIFTRUE
                dc.w computer2_hacksuccess
                dc.b S_QUIT

computer1script:dc.b S_CHECKITEM,ITEM_ACCESSLOG
                dc.b S_BRANCHIFTRUE
                dc.w computer1_gotaccesslog
                dc.b S_CHECKPLOTBIT,PB_GENERATOR
                dc.b S_BRANCHIFFALSE
                dc.w computer1_nopower
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_ADDITEM,ITEM_ACCESSLOG
                dc.b S_RUNCUTSCENE
                dc.b CUTSCENE_COMPUTER
computer1_nopower:
                dc.b S_TEXT
                dc.w computer1text1
                dc.b S_QUIT
computer1_gotaccesslog:
                dc.b S_TEXT
                dc.w nftdtext
                dc.b S_QUIT


        ;Script data for conversations
        ;-----------------------------

cmcdesk:        dc.b S_CHECKITEM,ITEM_ACCESSLOG
                dc.b S_BRANCHIFTRUE
                dc.w cmc_accesslog
                dc.b S_TEXT
                dc.w desktext1
                dc.b S_QUIT
cmc_accesslog:  dc.b S_CHECKPLOTBIT,PB_GUARDSALERTED
                dc.b S_BRANCHIFTRUE
                dc.w cmc_guardsalerted
                dc.b S_TEXT
                dc.w goattext6
                dc.b S_TEXT
                dc.w goattext7
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_TEXT
                dc.w desktext2
                dc.b S_SETPLOTBIT,PB_GUARDSALERTED
cmc_createguards:
                dc.b S_CREATEACTOR,20,76,ACT_GUARD1,0,$08
                dc.b S_CREATEACTOR,23,76,ACT_GUARD1,0,$08
                dc.b S_QUIT
cmc_guardsalerted:
                dc.b S_TEXT
                dc.w desktext3
                dc.b S_TEXT
                dc.w desktext4
                dc.b S_TEXT
                dc.w desktext5
                dc.b S_QUIT

scientist:      dc.b S_CHECKITEM,ITEM_LABKEYCARD
                dc.b S_BRANCHIFTRUE
                dc.w scientist_gotcard
                dc.b S_TEXT
                dc.w goattext10
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_ADDITEM,ITEM_LABKEYCARD
                dc.b S_TEXT
                dc.w scientisttext
                dc.b S_QUIT
scientist_gotcard:
                dc.b S_TEXT
                dc.w giventext
                dc.b S_QUIT

bofh:           dc.b S_CHECKITEM,ITEM_SRKEYCARD
                dc.b S_BRANCHIFTRUE
                dc.w scientist_gotcard
                dc.b S_TEXT
                dc.w goattext8
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_ADDITEM,ITEM_SRKEYCARD
                dc.b S_TEXT
                dc.w bofhtext
                dc.b S_QUIT

police:         dc.b S_CHECKPLOTBIT,PB_KNOWHAMMER
                dc.b S_BRANCHIFTRUE
                dc.w police_alldone
                dc.b S_TEXT
                dc.w goattext3
                dc.b S_TEXT
                dc.w policetext1
                dc.b S_SETPLOTBIT,PB_KNOWHAMMER
                dc.b S_QUIT
police_alldone: dc.b S_TEXT
                dc.w policetext2
                dc.b S_QUIT

asylum:         dc.b S_CHECKCURRENTTM,TM_ULTRASHRED
                dc.b S_BRANCHIFTRUE
                dc.w asylum_newdoctor
                dc.b S_TEXT
                dc.w asylumtext1
                dc.b S_QUIT
asylum_newdoctor:
                dc.b S_TEXT
                dc.w asylumtext2
                dc.b S_QUIT

colonel:        dc.b S_CHECKITEM,ITEM_HELIPADCARD
                dc.b S_BRANCHIFTRUE
                dc.w colonel_alldone
                dc.b S_TEXT
                dc.w goattext1
                dc.b S_TEXT
                dc.w coloneltext1
                dc.b S_TEXT
                dc.w coloneltext2
                dc.b S_TEXT
                dc.w coloneltext3
                dc.b S_TEXT
                dc.w coloneltext4
                dc.b S_TEXT
                dc.w coloneltext5
                dc.b S_TEXT
                dc.w goattext2
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_ADDITEM,ITEM_HELIPADCARD
                dc.b S_TEXT
                dc.w coloneltext6
                dc.b S_QUIT
colonel_alldone:dc.b S_TEXT
                dc.w toldalltext
                dc.b S_QUIT

prisonkeeper:   dc.b S_CHECKITEM,ITEM_CELLKEY
                dc.b S_BRANCHIFTRUE
                dc.w colonel_alldone
                dc.b S_TEXT
                dc.w prisontext1
                dc.b S_TEXT
                dc.w prisontext2
                dc.b S_TEXT
                dc.w prisontext3
                dc.b S_ADDSCORE,SCORE_10000
                dc.b S_ADDITEM,ITEM_CELLKEY
                dc.b S_TEXT
                dc.w prisontext4
                dc.b S_QUIT

axesmith:       dc.b S_CHECKTM, TM_IAN
                dc.b S_BRANCHIFTRUE
                dc.w axesmith_team
                dc.b S_CHECKPLOTBIT, PB_AXESMITH
                dc.b S_BRANCHIFTRUE
                dc.w axesmith_alreadytalked
                dc.b S_CHECKCURRENTTM, TM_GOAT
                dc.b S_BRANCHIFFALSE
                dc.w axesmith_alreadytalked
                dc.b S_TEXT
                dc.w goattext4
                dc.b S_TEXT
                dc.w goattext5
                dc.b S_ADDSCORE, SCORE_10000
                dc.b S_TEXT
                dc.w axesmithtext1
                dc.b S_TEXT
                dc.w axesmithtext2
                dc.b S_TEXT
                dc.w axesmithtext3
                dc.b S_TEXT
                dc.w axesmithtext4
                dc.b S_TEXT
                dc.w axesmithtext5
                dc.b S_SETPLOTBIT, PB_KNOWHAMMER
                dc.b S_SETPLOTBIT, PB_AXESMITH
                dc.b S_QUIT
axesmith_alreadytalked:
                dc.b S_TEXT
                dc.w axesmithtext6
                dc.b S_QUIT
axesmith_team:  dc.b S_TEXT
                dc.w axesmithtext7
                dc.b S_TEXT
                dc.w axesmithtext8
                dc.b S_QUIT

customer1:      dc.b S_TEXT
                dc.w customer1text
                dc.b S_QUIT

customer2:      dc.b S_TEXT
                dc.w customer2text
                dc.b S_QUIT

customer3:      dc.b S_TEXT
                dc.w customer3text
                dc.b S_QUIT

customer4:      dc.b S_TEXT
                dc.w customer4text
                dc.b S_QUIT

customer5:      dc.b S_TEXT
                dc.w customer5text
                dc.b S_QUIT

customer6:      dc.b S_TEXT
                dc.w customer6text
                dc.b S_QUIT

customer7:      dc.b S_TEXT
                dc.w customer7text
                dc.b S_QUIT

customer8:      dc.b S_TEXT
                dc.w customer8text
                dc.b S_QUIT

customer9:      dc.b S_TEXT
                dc.w customer9text
                dc.b S_QUIT

customer10:     dc.b S_TEXT
                dc.w customer10text
                dc.b S_QUIT

hammer:         dc.b S_CHECKTM,TM_IAN
                dc.b S_BRANCHIFTRUE
                dc.w hammer_mloss
                dc.b S_CHECKPLOTBIT,PB_HAMMER
                dc.b S_BRANCHIFTRUE
                dc.w hammer_spokento
                dc.b S_TEXT
                dc.w hammertext1
                dc.b S_TEXT
                dc.w hammertext2
                dc.b S_TEXT
                dc.w hammertext3
                dc.b S_TEXT
                dc.w hammertext4
                dc.b S_TEXT
                dc.w hammertext5
                dc.b S_SETPLOTBIT,PB_HAMMER
                dc.b S_QUIT
hammer_spokento:dc.b S_CHECKTM,TM_SNAKE
                dc.b S_BRANCHIFTRUE
                dc.w hammer_cantstandsnake
                dc.b S_TEXT
                dc.w hammertext6
hammer_joinquery:
                dc.b S_QUERY
                dc.w hammerjointext
                dc.w yesnotext
                dc.b S_BRANCHIFTRUE
                dc.w hammer_nojoin
                dc.b S_ADDSCORE,SCORE_25000
                dc.b S_JOINTEAM, TM_HAMMER
                dc.b S_DELETEACTOR, ACT_HAMMER
hammer_nojoin:  dc.b S_QUIT
hammer_cantstandsnake:
                dc.b S_TEXT
                dc.w hammertext7
                dc.b S_QUIT
hammer_mloss:   dc.b S_CHECKITEM,ITEM_ACCESSLOG
                dc.b S_BRANCHIFTRUE
                dc.w hammer_cmc
                dc.b S_TEXT
                dc.w mlosstext1
                dc.b S_TEXT
                dc.w mlosstext2
                dc.b S_TEXT
                dc.w mlosstext3
                dc.b S_TEXT
                dc.w mlosstext4
                dc.b S_TEXT
                dc.w mlosstext5
                dc.b S_TEXT
                dc.w mlosstext6
hammer_mloss2:  dc.b S_CHECKTM,TM_SNAKE
                dc.b S_BRANCHIFTRUE
                dc.w hammer_nojoin
                dc.b S_TEXT
                dc.w jointext
                dc.b S_JUMP
                dc.w hammer_joinquery
hammer_cmc:     dc.b S_TEXT
                dc.w cmctext
                dc.b S_JUMP
                dc.w hammer_mloss2

snake:          dc.b S_CHECKITEM, ITEM_RADIOGEAR
                dc.b S_BRANCHIFTRUE
                dc.w snake_getgear
                dc.b S_CHECKTM,TM_IAN
                dc.b S_BRANCHIFTRUE
                dc.w snake_mloss
                dc.b S_CHECKPLOTBIT, PB_GEARRETURNED
                dc.b S_BRANCHIFTRUE
                dc.w snake_askjoin
                dc.b S_TEXT
                dc.w snaketext1
                dc.b S_TEXT
                dc.w snaketext2
                dc.b S_TEXT
                dc.w snaketext3
                dc.b S_QUIT
snake_getgear:  dc.b S_ADDSCORE,SCORE_10000
                dc.b S_TEXT
                dc.w snaketext4
                dc.b S_SETPLOTBIT, PB_GEARRETURNED
                dc.b S_REMOVEITEM, ITEM_CTRLROOMKEY
                dc.b S_REMOVEITEM, ITEM_RADIOGEAR
                dc.b S_POKE
                dc.w mapdata+6*60+52
                dc.b 50
                dc.b S_POKE
                dc.w mapdata+6*60+53
                dc.b 51
                dc.b S_POKE
                dc.w mapdata+6*60+54
                dc.b 52
                dc.b S_CALLCODE
                dc.w snake_redraw
                dc.b S_CHECKTM,TM_IAN
                dc.b S_BRANCHIFTRUE
                dc.w snake_nobriefing
                dc.b S_CALLCODE
                dc.w snake_waitonehour
                dc.b S_TEXT
                dc.w snaketext5
                dc.b S_TEXT
                dc.w snaketext6
                dc.b S_TEXT
                dc.w snaketext7
                dc.b S_TEXT
                dc.w snaketext8
snake_nobriefing:dc.b S_QUIT
snake_askjoin:  dc.b S_CHECKTM,TM_HAMMER
                dc.b S_BRANCHIFTRUE
                dc.w snake_cantstandhammer
                dc.b S_TEXT
                dc.w snaketext9
snake_joinquery:dc.b S_QUERY
                dc.w snakejointext
                dc.w yesnotext
                dc.b S_BRANCHIFTRUE
                dc.w snake_nojoin
                dc.b S_ADDSCORE,SCORE_25000
                dc.b S_JOINTEAM, TM_SNAKE
                dc.b S_DELETEACTOR, ACT_SNAKE
snake_nojoin:   dc.b S_QUIT
snake_cantstandhammer:
                dc.b S_TEXT
                dc.w snaketext10
                dc.b S_TEXT
                dc.w snaketext11
                dc.b S_QUIT
snake_mloss:    dc.b S_CHECKITEM,ITEM_ACCESSLOG
                dc.b S_BRANCHIFTRUE
                dc.w snake_cmc
                dc.b S_TEXT
                dc.w mlosstext1
                dc.b S_TEXT
                dc.w mlosstext2
                dc.b S_TEXT
                dc.w mlosstext3
                dc.b S_TEXT
                dc.w mlosstext4
                dc.b S_TEXT
                dc.w mlosstext5
                dc.b S_TEXT
                dc.w mlosstext6
snake_mloss2:   dc.b S_CHECKTM,TM_HAMMER
                dc.b S_BRANCHIFTRUE
                dc.w snake_nojoin
                dc.b S_CHECKPLOTBIT,PB_GEARRETURNED
                dc.b S_BRANCHIFFALSE
                dc.w snake_nojoin
                dc.b S_TEXT
                dc.w jointext
                dc.b S_JUMP
                dc.w snake_joinquery
snake_cmc:      dc.b S_TEXT
                dc.w cmctext
                dc.b S_JUMP
                dc.w snake_mloss2


ultrashred:     dc.b S_CHECKITEM,ITEM_DOCTORSCOAT
                dc.b S_BRANCHIFTRUE
                dc.w ultrashred_escape
                dc.b S_CHECKCURRENTTM,TM_PHANTASM
                dc.b S_BRANCHIFTRUE
                dc.w ultrashred_visit
                dc.b S_TEXT
                dc.w ultrashredtext1
                dc.b S_TEXT
                dc.w ultrashredtext2
ultrashred_wantescape:
                dc.b S_TEXT
                dc.w ultrashredtext3
                dc.b S_TEXT
                dc.w ultrashredtext4
                dc.b S_QUIT
ultrashred_escape:
                dc.b S_ADDSCORE,SCORE_25000
                dc.b S_JOINTEAM,TM_ULTRASHRED
                dc.b S_TEXT
                dc.w ultrashredtext5
                dc.b S_DELETEACTOR,ACT_ULTRASHRED
                dc.b S_REMOVEITEM,ITEM_DOCTORSCOAT
                dc.b S_QUIT
ultrashred_visit:
                dc.b S_TEXT
                dc.w ultrashredtext6
                dc.b S_TEXT
                dc.w ultrashredtext7
                dc.b S_JUMP
                dc.w ultrashred_wantescape

gymkeeper:      dc.b S_POKE
                dc.w gymwelcometext+9
                dc.b $33
                dc.b S_POKE
                dc.w gymkeeper_credits
                dc.b $03
gymkeeper_common:
                dc.b S_CALLCODE
                dc.w gymkeeper_checkifpaid
                dc.b S_BRANCHIFTRUE
                dc.w gymkeeper_paid
                dc.b S_TEXT
                dc.w gymwelcometext
                dc.b S_QUERY
                dc.w gymquerytext
                dc.w yesnotext
                dc.b S_BRANCHIFTRUE
                dc.w gymkeeper_exit
                dc.b S_SUBCREDITS
gymkeeper_credits:dc.b $03
                dc.b S_BRANCHIFFALSE
                dc.w gymkeeper_nomoney
                dc.b S_CALLCODE
                dc.w gymkeeper_setpaidstate
                dc.b S_TEXT
                dc.w gymthankstext
                dc.b S_QUIT
gymkeeper_nomoney:dc.b S_TEXT
                dc.w creditstext
gymkeeper_exit: dc.b S_QUIT
gymkeeper_paid: dc.b S_TEXT
                dc.w gymalreadytext
                dc.b S_QUIT

gymkeeper2:     dc.b S_POKE
                dc.w gymwelcometext+9
                dc.b $35
                dc.b S_POKE
                dc.w gymkeeper_credits
                dc.b $05
                dc.b S_JUMP
                dc.w gymkeeper_common

        ;Shop data
        ;---------
        ;dc.w Welcome text address
        ;dc.b Item type,item ammo,item cost lo,item cost hi
        ;dc.b Next item type...

subcitygunshop: dc.w gunsnammotext
                dc.b ITEM_KNIFE,$00,$10,$00
                dc.b ITEM_NUNCHAKU,$00,$25,$00
                dc.b ITEM_PISTOL,$00,$50,$00
                dc.b ITEM_SHOTGUN,$00,$00,$01
                dc.b ITEM_SMG,$00,$50,$01
                dc.b ITEM_GRENADES,$01,$07,$00
                dc.b ITEM_9MMBULLETS,$50,$10,$00
                dc.b ITEM_SHELLS,$25,$15,$00
                dc.b ITEM_MEDIKIT,$01,$20,$00
                dc.b ITEM_NONE,$00,$00,$00

freecitygunshop:dc.w fcitygunstext
                dc.b ITEM_KNIFE,$00,$07,$00
                dc.b ITEM_PISTOL,$00,$40,$00
                dc.b ITEM_SHOTGUN,$00,$80,$00
                dc.b ITEM_FLAMETHR,$00,$00,$02
                dc.b ITEM_9MMBULLETS,$50,$10,$00
                dc.b ITEM_FUEL,$50,$10,$00
                dc.b ITEM_SHELLS,$25,$15,$00
                dc.b ITEM_MEDIKIT,$01,$15,$00
                dc.b ITEM_NONE,$00,$00,$00

metrocitygunshop:dc.w mcitygunstext
                dc.b ITEM_KNIFE,$00,$15,$00
                dc.b ITEM_NUNCHAKU,$00,$30,$00
                dc.b ITEM_PISTOL,$00,$60,$00
                dc.b ITEM_SHOTGUN,$00,$25,$01
                dc.b ITEM_SMG,$00,$75,$01
                dc.b ITEM_FLAMETHR,$00,$50,$02
                dc.b ITEM_MLAUNCHER,$00,$00,$05
                dc.b ITEM_GRENADES,$01,$07,$00
                dc.b ITEM_MISSILES,$01,$10,$00
                dc.b ITEM_FUEL,$50,$12,$00
                dc.b ITEM_9MMBULLETS,$50,$10,$00
                dc.b ITEM_SHELLS,$25,$15,$00
                dc.b ITEM_MEDIKIT,$01,$20,$00
                dc.b ITEM_NONE,$00,$00,$00

outpostgunshop: dc.w outpostgunstext
                dc.b ITEM_KNIFE,$00,$05,$00
                dc.b ITEM_NUNCHAKU,$00,$20,$00
                dc.b ITEM_PISTOL,$00,$30,$00
                dc.b ITEM_SHOTGUN,$00,$75,$00
                dc.b ITEM_SMG,$00,$25,$01
                dc.b ITEM_FLAMETHR,$00,$75,$01
                dc.b ITEM_9MMBULLETS,$50,$10,$00
                dc.b ITEM_FUEL,$50,$10,$00
                dc.b ITEM_GRENADES,$01,$10,$00
                dc.b ITEM_SHELLS,$25,$15,$00
                dc.b ITEM_MEDIKIT,$01,$20,$00
                dc.b ITEM_NONE,$00,$00,$00

bar:            dc.w 0
                dc.b ITEM_BEER,$01,$02,$00
                dc.b ITEM_NONE,$00,$00,$00

cheapbar:       dc.w 0
                dc.b ITEM_BEER,$01,$01,$00
                dc.b ITEM_NONE,$00,$00,$00

tavern:         dc.w taverntext
                dc.b ITEM_FOOD,$01,$03,$00
                dc.b ITEM_BEER,$01,$01,$00
                dc.b ITEM_NONE,$00,$00,$00

scripttbllo:    dc.b <sr_quit
                dc.b <sr_text
                dc.b <sr_clearplotbit
                dc.b <sr_setplotbit
                dc.b <sr_toggleplotbit
                dc.b <sr_checkplotbit
                dc.b <sr_checkitem
                dc.b <sr_branchiftrue
                dc.b <sr_branchiffalse
                dc.b <sr_jump
                dc.b <sr_subcredits
                dc.b <sr_callcode
                dc.b <sr_poke
                dc.b <sr_query
                dc.b <sr_checktm
                dc.b <sr_createactor
                dc.b <sr_jointeam
                dc.b <sr_deleteactor
                dc.b <sr_addscore
                dc.b <sr_additem
                dc.b <sr_removeitem
                dc.b <sr_checkcurrenttm
                dc.b <sr_runcutscene
                dc.b <sr_playtune
                dc.b <sr_initbitmapmode
                dc.b <sr_drawbitmap
                dc.b <sr_cutscenetext
                dc.b <sr_fadetune
                dc.b <sr_delay
                dc.b <sr_clearcutscenetext
                dc.b <sr_clearcutscenebitmap
                dc.b <sr_endscroll

scripttblhi:    dc.b >sr_quit
                dc.b >sr_text
                dc.b >sr_clearplotbit
                dc.b >sr_setplotbit
                dc.b >sr_toggleplotbit
                dc.b >sr_checkplotbit
                dc.b >sr_checkitem
                dc.b >sr_branchiftrue
                dc.b >sr_branchiffalse
                dc.b >sr_jump
                dc.b >sr_subcredits
                dc.b >sr_callcode
                dc.b >sr_poke
                dc.b >sr_query
                dc.b >sr_checktm
                dc.b >sr_createactor
                dc.b >sr_jointeam
                dc.b >sr_deleteactor
                dc.b >sr_addscore
                dc.b >sr_additem
                dc.b >sr_removeitem
                dc.b >sr_checkcurrenttm
                dc.b >sr_runcutscene
                dc.b >sr_playtune
                dc.b >sr_initbitmapmode
                dc.b >sr_drawbitmap
                dc.b >sr_cutscenetext
                dc.b >sr_fadetune
                dc.b >sr_delay
                dc.b >sr_clearcutscenetext
                dc.b >sr_clearcutscenebitmap
                dc.b >sr_endscroll


        ;TITLE.S data
        ;------------

flashcolortbl:  dc.b $00,$00,$06,$00
                dc.b $06,$06,$05,$06
                dc.b $05,$05,$07,$05
                dc.b $07,$07,$01,$07
                dc.b $01,$01,$07,$01
                dc.b $07,$07,$05,$07
                dc.b $05,$05,$06,$05
                dc.b $06,$06,$00,$06

logocolortbl:   dc.b $00,$00,$00,$0b,$0c,$0f,$07

tdurtbllo:      dc.b <190,<190,<382,<382,<382,<382,<382
tdurtblhi:      dc.b >190,>190,>382,>382,>382,>382,>382

trouttbllo:     dc.b <title_presents1
                dc.b <title_presents2
                dc.b <title_logo
                dc.b <title_hiscore
                dc.b <title_credits
                dc.b <title_controls
                dc.b <title_contacts

trouttblhi:     dc.b >title_presents1
                dc.b >title_presents2
                dc.b >title_logo
                dc.b >title_hiscore
                dc.b >title_credits
                dc.b >title_controls
                dc.b >title_contacts




        ;All textdata
        ;------------

prtext1:        dc.b "COVERT  BITOPS",0
                dc.b "PRESENTS",0
prtext2:        dc.b "AN OLDSKOOL PRODUCTION",0
                dc.b "IN 2000-2012",0
crtext:         dc.b "CODE & GFX......LASSE \\RNI",0
                dc.b "MUSIC...........HARRI AHOLA",0
                dc.b "JUHA JAAKKOLA",0
                dc.b "ANTTI KIVILAHTI",0
                dc.b "ANDERS PETTERSSON",0
                dc.b "MARTTI P[RSSINEN",0
                dc.b "TEEMU RIIHONEN",0
                dc.b "ULRIK RONNOVIUS",0
                dc.b "DANIEL WUIS",0
                dc.b "LASSE \\RNI",0
                dc.b "THANKS TO MAGNUS LIND (EXOMIZER) &",0
                dc.b "NINJA,DOC BACARDI,MAGERVALP (LOADER)",0
controltext:    dc.b "USE JOYSTICK IN PORT 2 OR KEYS",0
                dc.b "Q W E",0
                dc.b "A   D + SHIFT",0
                dc.b "Z X C",0
                dc.b "CHOOSE 'INSTRUCTIONS' FOR MORE DETAILS",0

contacttext:    dc.b "COVERT BITOPS WEBPAGE:",0
                dc.b "HTTP://COVERTBITOPS.C64.ORG",0

hstext:         dc.b "10 TRUEST WARRIORS",0
firetext:       dc.b "PRESS FIRE FOR MAIN MENU",0
gamemenutext:   dc.b "INTRODUCTION  ",0
                dc.b "START NEW GAME",0
                dc.b "CONTINUE GAME",0
                dc.b "INSTRUCTIONS",0
                dc.b "EXIT TO OS",0
confirmmenutext:dc.b "CONFIRM EXIT",0
                dc.b "BACK TO MENU",0,0
continuemenutext:dc.b "CONTINUE",0
                dc.b "PASSWORD",0,0
loaderrortext:  dc.b "LOAD ERROR - PRESS FIRE TO RETRY",0
selecttmtxt:    dc.b "SELECT TEAMMEMBER",0
tmnametbl:      dc.b "GOAT    "
                dc.b "IAN     "
                dc.b "PHANTASM"
                dc.b "HAMMER  "
                dc.b "SNAKE   "
                dc.b "ULTRSHRD"
healthtxt:      dc.b "HEALTH"
outtxt:         dc.b "OUT"
agilitytxt:     dc.b "AGI"
strengthtxt:    dc.b "STR"
vitalitytxt:    dc.b "VIT"
exptxt:         dc.b "EP "
abilitynames:   dc.b "AGILITY "
                dc.b "STRENGTH"
                dc.b "VITALITY"
dayletter1tbl:  dc.b "MTWTFSS"
dayletter2tbl:  dc.b "OUEHRAU"
dayletter3tbl:  dc.b "NEDUITN"

buytext:        dc.b "                     COST:000    CRED:000",0
improvetext:    dc.b "IMPROVE          FOR 000 EXP.POINTS",0
exittext:       dc.b "EXIT",0
enterpwdtext:   dc.b "ENTER PASSWORD WITH KEYBOARD",0
pwdtext:        dc.b "YOUR PASSWORD IS",0
itemname1:      dc.b "FISTS"
itemname0:      dc.b 0
itemname2:      dc.b "CAT-5 WHIP",0
itemname3:      dc.b "KNIFE",0
itemname4:      dc.b "NUNCHAKU",0
itemname5:      dc.b "GRENADES",0
itemname6:      dc.b "PISTOL",0
itemname7:      dc.b "SHOTGUN",0
itemname8:      dc.b "SUBMACHINEGUN",0
itemname9:      dc.b "FLAME THROWER",0
itemname10:     dc.b "MISS.LAUNCHER",0
itemname11:     dc.b "LASER RIFLE",0
itemname12:     dc.b "GAS FIST",0
itemname13:     dc.b "MEDIKIT",0
itemname14:     dc.b "FOOD",0
itemname15:     dc.b "BEER",0
itemname16:     dc.b "CREDITS",0
itemname17:     dc.b "9MM BULLETS",0
itemname18:     dc.b "SHOTGUN SHELLS",0
itemname19:     dc.b "MINI-MISSILES",0
itemname20:     dc.b "FLAMETHR.FUEL",0
itemname21:     dc.b "CHARGE CELLS",0
itemname22:     dc.b "CTRL.ROOM KEY",0
itemname23:     dc.b "RADIO GEAR",0
itemname24:     dc.b "H-PAD KEYCARD",0
itemname25:     dc.b "CELL KEY",0
itemname26:     dc.b "GUITAR PICK",0
itemname27:     dc.b "APARTMENT KEY",0
itemname28:     dc.b "LINUX BOOTDISK",0
itemname29:     dc.b "CD-ROM DISK",0
itemname30:     dc.b "ACCESS LOG",0
itemname31:     dc.b "STAIRS KEYCARD",0
itemname32:     dc.b "SRV.ROOM CARD",0
itemname33:     dc.b "LAB KEYCARD",0
itemname34:     dc.b "DOCTOR'S COAT",0

pickeduptext:   dc.b "PICKED UP ",0
                ds.b ITEMNAMELENGTH+1,0

yesnotext:      dc.b "YES",0
                dc.b "NO",0

cheatstring:    dc.b KEY_E
                dc.b KEY_N
                dc.b KEY_T
                dc.b KEY_R
                dc.b KEY_O
                dc.b KEY_P
                dc.b KEY_Y
                dc.b KEY_SPACE
                dc.b KEY_R
                dc.b KEY_E
                dc.b KEY_V
                dc.b KEY_E
                dc.b KEY_R
                dc.b KEY_S
                dc.b KEY_A
                dc.b KEY_L
                dc.b $ff

                     ;01234567890123456789
hmg_hacktext1:  dc.b "BACKDOOR ID SCEPTRE "
hmg_hacktext2:  dc.b "PASSWORD THRONE     "

hmg_text1:      dc.b "LETTER A-Z?",0
hmg_text2:      dc.b "SWAP",0
hmg_text3:      dc.b "WITH",0

hmg_swaptime:       dc.b 0

                include gmsgpack.s

        ;Variables
        ;---------

starsy:         dc.b 0
starsscreen:    dc.b 0
generatornumber:dc.b 0
bganimdelay:    dc.b 0
parallaxcount1: dc.b 0
parallaxcount2: dc.b 0
parallaxcount3: dc.b 0
parallaxcount4: dc.b 0
levelnum:       dc.b 0
loadedlevel:    dc.b $ff
loadedsprites:  dc.b $ff
loadedtm:       dc.b $ff
loadedmusicbank:dc.b $ff
lvlactstart:    dc.b 0
itemflashcolor: dc.b 0
actxl:          ds.b MAXACT,0
actxh:          ds.b MAXACT,0
actyl:          ds.b MAXACT,0
actyh:          ds.b MAXACT,0
actsx:          ds.b MAXACT,0
actsy:          ds.b MAXACT,0
actt:           ds.b MAXACT,0
actf:           ds.b MAXACT,0
actfd:          ds.b MAXACT,0
actbits:        ds.b MAXACT,0
actd:           ds.b MAXACT,0
acthp:          ds.b MAXACT,0
actorg:         ds.b MAXACT,0
actattk:        ds.b MAXACT,0
actattkd:       ds.b MAXACT,0
tmagility:      ds.b MAXTM,0
tmstrength:     ds.b MAXTM,0
tmvitality:     ds.b MAXTM,0
tmhp:           ds.b MAXTM,0
tmstat:         ds.b MAXTM,0
tmhealspd:      ds.b MAXTM,0
tmhealcntlo:    ds.b MAXTM,0
tmhealcnthi:    ds.b MAXTM,0
tmexpcount:     ds.b MAXTM,0
tmexplo:        ds.b MAXTM,0
tmexphi:        ds.b MAXTM,0
tmselrow:       ds.b MAXTM,0
score:          dc.b 0,0,0,0
daynumber:      dc.b 0
timemin:        dc.b 0
timehour:       dc.b 0
timeframe:      dc.b 0
meleebreak:     dc.b 0
invview:        dc.b 0
invselect:      dc.b 0
invtype:        ds.b INVENTORYSIZE+1,0  ;One extra zero for SORTINVENTORY
invammolo:      ds.b INVENTORYSIZE+1,0  ;and REMOVEITEM
invammohi:      ds.b INVENTORYSIZE+1,0
gunindex:       dc.b $ff
prevgunframe:   dc.b $ff
gunframe:       dc.b $ff
enterdoornum:   dc.b $ff
npccollnum:     dc.b 0
npccollindex:   dc.b 0
commnum:        dc.b 0
bossfight:      dc.b 0
roundtrips:     dc.b 0
helicopterdefeated:dc.b 0
prevbossfight:  dc.b 0
sresult:        dc.b 0
autoremovetime: dc.b 0
autoremovedoornum:dc.b 0
lastdoornum:    dc.b 0
spendtimecount: dc.b 0
improvepossible:dc.b 0,0,0,1
improvecostlo:  ds.b 3,0
improvecosthi:  ds.b 3,0
shopselect:     dc.b 0
creditslo:      dc.b 0
creditshi:      dc.b 0
pricelo:        dc.b 0
pricehi:        dc.b 0
pausemode:      dc.b 0
gamemenuchoice: dc.b 1
musicmode:      dc.b 1
sfxmode:        dc.b 1
tunenumber:     dc.b MUSIC_SILENCE
titlebigtmframe:dc.b 0
titlefire:      dc.b 0
titleexit:      dc.b 0
titledurlo:     dc.b 0
titledurhi:     dc.b 0
titlefade:      dc.b 0
hiscorerow:     dc.b 0
menutimeout:    dc.b 0
menuchoice:     dc.b 0
hiscoreindex:   dc.b 0
menuchoices:    dc.b 0
hiscorecursor:  dc.b 0
titlephase:     dc.b 0
msgtime:        dc.b 0
msgstatus:      dc.b MSG_OFF
msgcolumn:      dc.b 0
msgrow:         dc.b 0
msgpackedword:  dc.b 0
invupdateflag:  dc.b 0
prevtm:         dc.b $ff
prevagility:    dc.b $ff
prevstrength:   dc.b $ff
prevvitality:   dc.b $ff
prevscore:      dc.b $ff,$ff,$ff,$ff
prevexp:        dc.b $ff,$ff
prevtimemin:    dc.b $ff
prevtimehour:   dc.b $ff
prevdaynumber:  dc.b $ff
prevhp:         dc.b $ff
plotbits:       dc.b 0,0
cheatindex:     dc.b 0
energycheat:    dc.b 0
pwdbitcount:    dc.b 0
pwdbytecount:   dc.b 0
pwd:            ds.b PWDBYTESIZE,0

